/**
 * Area.java -- 
 *
 * @version $Revision: 1.4 $, $Date: 2003/03/06 07:23:50 $
 */

import java.text.DecimalFormat;

public class Area {
    /** ɽ饹 */
    public static class Point {
        public double x, y;
        public Point(double x, double y) {  this.x = x;  this.y = y;  }
    }

    /** ѷ OAB  */
    public static double getValue(Point a, Point b) {
        return (a.x * b.y - b.x * a.y) / 2;
    }

    /** ¿ѷ */
    public static double getValue(Point[] p) {
        double sum = getValue(p[p.length - 1], p[0]);
        for (int i = 1; i < p.length; i++) sum += getValue(p[i - 1], p[i]);
        return sum;
    }


    /*
     * 
     * Ⱦ 1 αߤܤ n ѷ
     */
    static double areaOfRegularPolygon(int n) {
        double d = 2 * Math.PI / n;  // = 2/n
        Area.Point[] p = new Area.Point[n];

        for (int k = 0; k < n; k++)
            p[k] = new Area.Point(Math.cos(d * k), Math.sin(d * k));
        return Area.getValue(p);
    }

    /**
     * ץǤ<br>
     * Ⱦ1αߤܤnѷѤơ
     * <code>0.5*n*sin(2*pi/n)</code>ӤƤޤ
     */
    public static void main(String[] args) {
        Area.Point[] pt = {
            new Area.Point(1, 1), new Area.Point(3, 2),
            new Area.Point(2, 4), new Area.Point(0, 2),
        };
        System.out.println(" = " + Area.getValue(pt));

        int n = pt.length;
        for (int i = 0; i < n / 2; i++) {
            Area.Point swap = pt[n - 1 - i];
            pt[n - 1 - i] = pt[i];
            pt[i] = swap;
        }
        System.out.println(" = " + Area.getValue(pt));

        final DecimalFormat DF = new DecimalFormat(" 0.0000000000000");
        System.out.println();
        System.out.println(" n ѷ");
        System.out.println(" n       getValue()     0.5*n*sin(2/n)");
        for (n = 3; n <= 20; n++)
            System.out.println((n < 10 ? "  " : " ") + n + "  "
                               + DF.format(areaOfRegularPolygon(n)) + "  "
                               + DF.format(0.5 * n * Math.sin(2 * Math.PI / n)));
    }
}
