/**
* BITools.java -- BigInteger ƻ
* @version $Revision: 1.7 $, $Date: 2003/03/14 19:32:28 $
*/
import java.math.*;
import java.util.*;
/**
*BigInteger ξƻ񽸤󶡤ޤ
*/
public class BITools {
    /**
    *10 ʤǤνϷݻƤޤ
    */
    public static int decNumber;   // Ϸ
    private static long seed = System.currentTimeMillis();
    /**
    * 10ʤǤۤ dec ֤ޤ
    */
    public static BigInteger random(int dec) {
        int bits = (int)(dec * Math.log(10.0) / Math.log(2.0));
        Random     rnd  = new Random(seed++);
        return new BigInteger(bits, rnd);
    }
    /**
    * a = A2<sup>m</sup>, b = B  2<sup>n</sup> Ѥ
    * C = (AB)2<sup>m + n</sup> ȤƷ׻ޤ<br>
    * BigInteger  a.multiply(b) ϲ̥ӥåȤ 0 ǤäƤ⡤ӥå
    * ׻褦ǡ֤뤿Ǥ
    * @return ab
    */
    public static BigInteger biMult(BigInteger a, BigInteger b) {
        if (a.signum() == 0 || b.signum() == 0) return BigInteger.ZERO;
        int m = a.getLowestSetBit(), n = b.getLowestSetBit();
        if (m == 0 && n == 0) return a.multiply(b);
        BigInteger am = a.shiftRight(m), bn = b.shiftRight(n);

        return am.multiply(bn).shiftLeft(m + n);
    }
    /**
    * BigInteger r  10 ɽǤηγͤޤ
    */
    public static int biFig10(BigInteger r) {
        return (int)(r.bitLength() * Math.log(2) / Math.log(10)) + 1;
    }
    /**
    * 0  (n - 1) ӥåȤ 0 ˤޤn  0 ξϡΤޤ a ֤ޤ
    */
    public static BigInteger setBitsZeroLower(BigInteger a, int n) {
        if (n <= 0) return a;
        return a.shiftRight(n).shiftLeft(n);
    }
    /**
    * ̤ 0 Ǥʤӥåȿ֤ޤ<br>
    * <b></b><code> 1100 0101 1010 0000 0000</code> Ǥ 11 ֤ޤ
    */
    public static int nonZeroBitLength(BigInteger a) {
        return a.bitLength() - a.getLowestSetBit();
    }
    /**
    * BigInteger a  p ڤ <code><b>[+|-]abcd ...xxx</b></code> ʸѴޤ
    * 10 ɽǤη {@link #decNumber} äƤޤ
    *@param delimiter ڤʸͿޤ
    */
    public static String toDelimiterString(BigInteger a, int p, char delimiter) {
        if (a.signum() == 0) return new String("0");

        char[] r = a.toString().toCharArray();
        int len  = r.length, buffLen = len + len / p + 1;
        decNumber = a.signum() > 0 ? len : len - 1;
        StringBuffer sb = new StringBuffer(buffLen);
        int top = len % p, i;

        if (top > 0) {
            sb.append(r, 0, top);
            if (r[top -1] != '-') sb.append(delimiter);   // "- abc..." ȤϤʤ
        }
        for (i = top; i < len - p; i += p) {
            sb.append(r, i, p);  sb.append(delimiter);
        }
        sb.append(r, i, p);
        return sb.toString();
    }
    /**
    * BigInteger a  p ڤ <code><b>[+|-]abcd ...xxx</b></code> ʸѴޤ
    * 10 ɽǤη {@link #decNumber} äƤޤ
    * ڤʸ϶' 'Ǥ
    */
    public static String toDelimiterString(BigInteger a, int p) {
        return toDelimiterString(a, p, ' ');
    }
    /**
    * BigInteger a  p ڤ <code><b>[+|-]abcd ...xxx</b></code> ǽϤޤ
    * ڤʸ϶' 'ǤϤκǸ˲Ԥޤ
    *@return 10 ɽǤνϷ
    */
    public static int print(BigInteger a, int p) {
        System.out.println(toDelimiterString(a, p));
        return decNumber;
    }
    /**
    * BigInteger a  p ڤ <code><b>[+|-]abcd ...xxx</b></code> ǽϤޤ
    *ϤκǸ˲Ԥޤ
    *@param delimiter ڤʸͿޤ
    *@return 10 ɽǤνϷ
    */
    public static int print(BigInteger a, int p, char delimiter) {
        System.out.println(toDelimiterString(a, p, delimiter));
        return decNumber;
    }
    /**
    *ƥѥץǤ
    */
    public static void main(String[] args) {
        int f;
        do { f = (int)(60 * Math.random()); } while (f < 20);
        BigInteger a = random(f);

        System.out.println("a = " + a);
        print(a, 3, ',');
        a = a.negate();
        System.out.println("a = " + a);
        print(a, 3, ',');
    }
}
