/**
* Bernoulli.java -- Bernoulli (٥̡) 
* BigInteger 饹Ȥ
* @version $Revision: 1.7 $, $Date: 2003/03/18 01:25:55 $
*/
import java.math.*;
/**
*Bernoulli (٥̡) 3ĤˡǷ׻ޤ
*@see GCD
*/
public class Bernoulli {
    /**
    *double ȤäơBernoulli (٥̡) <code> b[] </code>˵ޤ<br>
    * <code>b[0] = 0, b[1] = |B(2)|, b[2] = |B(4)|, ... b[n-1] = |B(2*(n-1))|</code><br>
    *ǡn = b.length Ǥ<br>
    *㡧 B(40) ޤǵˤ n = 40/2 + 1 = 21 ˤޤ
    */
    public static void numbers(double[] b) {
        int m = 2 * (b.length  - 1);
        double q = 1, t[] = new double[m + 1];

        t[1] = 1;
        for (int n = 2; n <= m; n++) {
            for (int i = 1; i < n; i++) t[i - 1] = i * t[i];
            t[n - 1] = 0;
            for (int i = n; i >= 2; i--) t[i] += t[i - 2];
            if (n % 2 == 0) {
                q *= 4;  b[n/2] = (n * t[0]) / (q * (q - 1));
            }
        }
    }
    /**
    *long ȤäơBernoulli (٥̡) ʬɽޤ
    *ΤʤΤ B(22) ޤǤǤ
    */
    public static void numbers(int m) {
        long q = 1;
        long t[] = new long[m + 1];

        t[1] = 1;
        for (int n = 2; n <= m; n++) {
            for (int i = 1; i < n; i++) t[i - 1] = i * t[i];
            t[n - 1] = 0;
            for (int i = n; i >= 2; i--) t[i] += t[i - 2];
            if (n % 2 == 0) {
                q *= 4;
                long b1 = n * t[0], b2 = q * (q - 1);
                long d = GCD.gcd(b1, b2);  b1 /= d;  b2 /= d;
                System.out.println("|B(" + n + ")| = " + b1 + "/" + b2);
            }
        }
    }

    /**
    *BigInteger ȤäơBernoulli (٥̡) ʬɽޤ
    */
    public static void biNumbers(int m) {
        BigInteger q = BigInteger.ONE;  // q = 1
        BigInteger t[] = new BigInteger[m + 1];

        for (int i = 0; i <= m; i++) t[i] = BigInteger.ZERO; // 0 ǽ

        t[1] = BigInteger.ONE;  // t[1] = 1
        for (int n = 2; n <= m; n++) {
            for (int i = 1; i < n; i++)
                t[i - 1] = t[i].multiply(BigInteger.valueOf(i)); // t[i - 1] = i * t[i]
            t[n - 1] = BigInteger.ZERO; // t[n - 1] = 0
            for (int i = n; i >= 2; i--) t[i] = t[i].add(t[i - 2]);// t[i] += t[i - 2]
            if (n % 2 == 0) {
                BigInteger b1, b2, d, q1;
                q  = q.shiftLeft(2);  // q *= 4
                b1 = t[0].multiply(BigInteger.valueOf(n)); // b1 = n * t[0];
                q1 = q.subtract(BigInteger.ONE); // q1 = q - 1
                b2 = q.multiply(q1); // b2 = q * (q - 1)
                // b1/b2 ʬˤɽ
                d = b1.gcd(b2);  b1 = b1.divide(d);  b2 = b2.divide(d);
                System.out.println("|B(" + n + ")| = " + b1 + "/" + b2);
            }
        }
    }

    public static void main(String[] args) {
        final int N = 40;

        System.out.println("long  B(m)(m >= 24) overflow 롣");
        numbers(N);

        System.out.println("\ndouble[] ");
        int bn = N / 2 + 1;
        double B[] = new double[bn];
        numbers(B);
        for (int i = 0; i < bn; i++) System.out.println("|B(" + (2 * i) + ")| = " + B[i]);

        System.out.println("\nBigInteger ");
        biNumbers(N);
    }
}
