/*
* BinarySplitPi2.java -- binary splitting method ˤФη׻
* Chudnovskys ˡˤ롣
* @version $Revision: 1.3 $, $Date: 2003/05/12 10:24:56 $
*/
import java.math.*;

/**
*Chudnovskys ˡ binary splitting ˡȤäƱ߼Ψ
* BigDecimal Ƿ׻ޤ<br>
*ƵǤѤƤޤ
*@see BinarySplitE
*@see BinarySplit2
*/

public class BinarySplitPi2 extends BinarySplit2 {
    static final BigDecimal A = BigDecimal.valueOf(13591409L);
    static final BigDecimal B = BigDecimal.valueOf(545140134L);
    static final long      LD = 640320L;
    static final BigDecimal C = BigDecimal.valueOf((LD * LD * LD)/24L);

    BinarySplitPi2(int L, int f) { super(L, f); }

    public BigDecimal bsA(int k) { // A(k) = A + B * k
        return A.add(B.multiply(BigDecimal.valueOf(k)));
    }
    public BigDecimal bsB(int k) { // B(k) = - (2 * k + 1) *(6 * k + 1) * (6 * k + 5)
        long p = - (2L * k + 1L), q = 6L * k + 1L, r = 6L * k + 5L;
        BigDecimal bk = BigDecimal.valueOf(p);
        return bk.multiply(BigDecimal.valueOf(q)).multiply(BigDecimal.valueOf(r));
    }
    public BigDecimal bsC(int k) { // C(0) = 1, C(k) = C * k^3
        if (k == 0) return BDTools.ONE;
        BigDecimal bik = BigDecimal.valueOf(k);

        return C.multiply(BDPower.power(bik, 3, N()));
    }
    public BigDecimal getValue() {
        putTogether();
        BigDecimal pi = getValue(true), // BinarySplit2 class  getValue()
                    a = BDSqrt.bdSqrt(BigDecimal.valueOf(10005L), N());
        pi = BDMult.bdMult(pi, a, N());
        pi = BDMult.bdMult(pi, BigDecimal.valueOf(426880L), N());

        return pi;
    }
    public static void main(String[] args) {
        final int L = 1024 * 4;  // ƵǤǤ L= 2^n ǤʤȤ褤
        int f = (int)(0.8 * L);
        long start, time;
        BinarySplitPi2 chPi = new BinarySplitPi2(L, f);

        start = System.currentTimeMillis();
        BigDecimal pi = chPi.getValue();
        time = System.currentTimeMillis() - start;
        System.out.println("Chudnovskys pi =");
        BDTools.precision = f; // Ϸꡣ
        BDTools.print(pi, 10);
        System.out.print("Ϸ = " + BDTools.decNumber + ", f = " + f);
        System.out.print("  ׻ : " + time + "(ms)");
        System.out.print("   : " + chPi.N());
        System.out.println("   : " + chPi.upTo());

    // MultiPrecision.pi() Ȥ
        int fm = (int)(f * Math.log(10) / Math.log(MultiPrecision.RADIX));
        MultiPrecision m = new MultiPrecision(fm);
        start = System.currentTimeMillis();
        String ms = m.toString(m.pi());  // Ѵޤ
        time = System.currentTimeMillis() - start;
        BigDecimal mpi = new BigDecimal(ms), d;
        d = pi.subtract(mpi);
        System.out.print("MultiPrecision.pi() η׻ : " + time + "(ms)  ");
        System.out.println("diffrence = " + BDTools.toDoubleString(d));
    }
}
