/**
 * BisectionTest.java -- 2ʬˡ(bisection method)λ
 *
 * @version $Revision: 1.3 $, $Date: 2003/03/02 13:51:23 $
 */

public class BisectionTest {
    public static void main(String[] args) {
        Function2 f = new Function2(1, 0, -2);  // x^2 - 2

        double x = Bisection.solve(f, 1, 2, 0);  // [1,2] ǲ
        System.out.println("solve f(x) = 0");
        System.out.println("x = " + x);
        System.out.println("f(x) = " + f.of(x));

        System.out.println();  // [-2, 2] ǺǾͤ
        x = FibonacciSearch.minimize(f, -2, 2, 1e-10);
        System.out.println("minimize f(x)");
        System.out.println("x = " + x);
        System.out.println("f(x) = " + f.of(x));
    }
}

/** 2ؿ ax^2 + bx + c */
class Function2 implements Bisection.Function, FibonacciSearch.Function {
    private double a, b, c;
    public Function2(double a, double b, double c) {
        this.a = a;  this.b = b;  this.c = c;
    }
    public double of(double x) {  return (a * x + b) * x + c;  }
}
