/**
 *  CCurve.java -- C
 *  (DrawOneByOnePanel.java, Plotter.java Ȥ)
 *
 *  @version $Revision: 1.3 $, $Date: 2003/03/18 10:05:54 $
 */

import java.awt.*;
import javax.swing.*;

public class CCurve extends DrawOneByOnePanel {
    static final int WIDTH = 400,  HEIGHT = WIDTH * 5 / 8;
    private int order;  // ̿

    public CCurve(int order) {
        super(WIDTH + 1, HEIGHT + 1, 0);  this.order = order;
    }

    public int getOrder() {  return order;  }

    private void draw(Plotter pt, int i, double dx, double dy) {
        if (i == 0) {
            pt.drawRelative(dx, dy);
            sleep(500 / order / order);  // ɽԤ
            return;
        }
        draw(pt, i - 1, (dx + dy) / 2, (dy - dx) / 2);
        draw(pt, i - 1, (dx - dy) / 2, (dy + dx) / 2);
    }

    synchronized public void drawSlowly(Graphics2D g) {
        g.translate(WIDTH / 2, HEIGHT);  g.scale(1, -1);  // 沼
        Plotter pt = new Plotter(g);
        pt.moveTo(-WIDTH / 4, WIDTH / 2);  draw(pt, order, WIDTH / 2, 0);
    }

    public static void main(String[] args) {
        JFrame frame = new JFrame("C ");
        CCurve p1 = new CCurve(10);
        CCurve p2 = new CCurve(12);
        Container c = frame.getContentPane();

        Box b = new Box(BoxLayout.Y_AXIS);
        b.add(new JLabel("̿ = " + p1.getOrder()));
        b.add(p1);
        c.add(b, BorderLayout.WEST);

        b = new Box(BoxLayout.Y_AXIS);
        b.add(new JLabel("̿ = " + p2.getOrder()));
        b.add(p2);
        c.add(b, BorderLayout.EAST);

        frame.pack();               // Ŭڤ礭
        frame.setDefaultCloseOperation(frame.EXIT_ON_CLOSE);
        frame.setResizable(false);  // ѹԲ
        frame.setVisible(true);     // ɽ
        p1.start();
        p2.start();
    }
}
