/*
* CRC16.java -- CRC
* @version $Revision: 1.1 $, $Date: 2003/03/20 11:08:19 $
*/
/**
* 16 ӥåȤ CRC  2 Ĥˡǵޤ
*/

public class CRC16 {
    static final int CRCPOLY1 = 0x1021;  // x^{16}+x^{12}+x^5+1
    static final int CRCPOLY2 = 0x8408;  // ž
    static final int BYTE_BIT = 8;       // ХȤΥӥåȿ
    /**
    * 16 ӥåȤ CRC ˡ 1 ǵޤ
    *@param c ǡͿޤ
    *@return CRC ֤ͤޤ
    */
    public static int method1(byte c[]) {
        int r = 0xFFFF;

        for (int i = 0; i < c.length; i++) {
            r ^= (c[i] & 0xFF) << (16 - BYTE_BIT);
            for (int j = 0; j < BYTE_BIT; j++)
                if ((r & 0x8000) != 0) r = (r << 1) ^ CRCPOLY1;
                else                   r <<= 1;
        }
        return ~r & 0xFFFF;
    }
    /**
    * 16 ӥåȤ CRC ˡ 2 ǵޤ
    *@param c ǡͿޤ
    *@return CRC ֤ͤޤ
    */
    public static int method2(byte c[]) {
        int r = 0xFFFF;

        for (int i = 0; i < c.length; i++) {
            r ^= (c[i] & 0xFF);
            for (int j = 0; j < BYTE_BIT; j++)
                if ((r & 1) != 0) r = (r >> 1) ^ CRCPOLY2;
                else              r >>= 1;
        }
        return r ^ 0xFFFF;
    }
    /**
    * ƥѡʣХʸΥƥȤޤ
    */
    public static void main(String[] args) {
                                                               // method1 / method2
        String s1 = "Java Ǥ char 16ӥå̵", // 4F4F / E456
               s2 = "Hello, world!";                           // AD2D / 1EB5
        byte[] b1 = s1.getBytes(), b2 = s2.getBytes();  // byte[] Ѵ

      // CRC ͤ򣱣ʿɽ롣
        System.out.println("method1(" + s1 + ") = "
            + Integer.toHexString( method1(b1) ).toUpperCase());
        System.out.println("method2(" + s1 + ") = "
            + Integer.toHexString( method2(b1) ).toUpperCase());

        System.out.println("method1(" + s2 + ") = "
            + Integer.toHexString( method1(b2) ).toUpperCase());
        System.out.println("method2(" + s2 + ") = "
            + Integer.toHexString( method2(b2) ).toUpperCase());
    }
}
