/*
* CRC32.java -- CRC
* $Revision: 1.2 $, $Date: 2003/04/28 23:23:15 $
*
*/

/**
* 32 ӥåȤ CRC  2 Ĥˡǵޤ
* @see java.util.zip.CRC32
*/

public class CRC32 {
    static final int CRCPOLY1 = 0x04C11DB7;
    /* x^{32}+x^{26}+x^{23}+x^{22}+x^{16}+x^{12}+x^{11]+
       x^{10}+x^8+x^7+x^5+x^4+x^2+x^1+1 */
    static final int CRCPOLY2 = 0xEDB88320;  // ž
    static final int BYTE_BIT = 8;       // ХȤΥӥåȿ
    static final int CRC_BIT  = 32;      // CRC Υӥåȿ
    static final int CRC_MASK = 0xFFFFFFFF;
    /**
    * 32 ӥåȤ CRC ˡ 1 ǵޤ
    *@param c ǡͿޤ
    *@return CRC ֤ͤޤ
    */
    public static int method1(byte c[]) {
        int r = CRC_MASK;

        for (int i = 0; i < c.length; i++) {
            r ^= (int)(c[i] & 0xFF) << (CRC_BIT - BYTE_BIT);
            for (int j = 0; j < BYTE_BIT; j++)
                if ((r & 0x80000000) != 0) r = (r << 1) ^ CRCPOLY1;
                else                       r <<= 1;
        }
        return ~r & CRC_MASK;
    }
    /**
    * 32 ӥåȤ CRC ˡ 2 ǵޤ
    *@param c ǡͿޤ
    *@return CRC ֤ͤޤ
    */
    public static int method2(byte c[]) {
        int r = CRC_MASK;

        for (int i = 0; i < c.length; i++) {
            r ^= (c[i] & 0xFF);
            for (int j = 0; j < BYTE_BIT; j++)
                if ((r & 1) != 0) r = (r >>> 1) ^ CRCPOLY2;
                else              r = (r >>> 1);  //  r >>= 1;
        }
        return r ^ CRC_MASK;
    }
    /**
    * ƥѡʣХʸΥƥȤޤ
    */
    public static void main(String[] args) {
                                                               // method1 / method2
        String s1 = "Java Ǥ char 16ӥå̵", // 1E28E1C1 / DAF9EBA1
               s2 = "Hello, world!";                           // 8E9A7706 / EBE6C6E6
        byte[] b1 = s1.getBytes(), b2 = s2.getBytes();  // byte[] Ѵ

      // CRCͤ򣱣ʿɽ롣
        System.out.println("method1(" + s1 + ") = "
            + Integer.toHexString( method1(b1) ).toUpperCase());
        System.out.println("method2(" + s1 + ") = "
            + Integer.toHexString( method2(b1) ).toUpperCase());
        System.out.println("method1(" + s2 + ") = "
            + Integer.toHexString( method1(b2) ).toUpperCase());
        System.out.println("method2(" + s2 + ") = "
            + Integer.toHexString( method2(b2) ).toUpperCase());


      // Java CRC32method2()Ʊ֤ͤ
        java.util.zip.CRC32 javaCRC32s1 = new java.util.zip.CRC32();
        java.util.zip.CRC32 javaCRC32s2 = new java.util.zip.CRC32();
        System.out.println("\n---------- CRC32() of Java -------------- ");
        javaCRC32s1.update(b1);
        System.out.println(s1 + " = "
            + Long.toHexString(javaCRC32s1.getValue()).toUpperCase());
        javaCRC32s2.update(b2);
        System.out.println(s2 + " = "
            + Long.toHexString(javaCRC32s2.getValue()).toUpperCase());
    }
}
