/**
 *  Dragon.java -- ɥ饴󥫡֡ʺƵǡ
 *  (DrawOneByOnePanel.java, Plotter.java Ȥ)
 *
 *  @version $Revision: 1.8 $, $Date: 2003/03/18 10:05:53 $
 */

import java.awt.*;
import javax.swing.*;

public class Dragon extends DrawOneByOnePanel {
    static final int WIDTH = 400,  HEIGHT = 300;
    private int order;  // ̿

    public Dragon(int order) {
        super(WIDTH, HEIGHT, 0);  this.order = order;
    }

    public int getOrder() {  return order;  }

    private void draw(Plotter pt, int i, double dx, double dy, int sign) {
        if (i == 0) {
            pt.drawRelative(dx, dy);
            sleep(500 / order / order);  // ɽԤ
            return;
        }
        draw(pt, i - 1, (dx - sign * dy) / 2, (dy + sign * dx) / 2,  1);
        draw(pt, i - 1, (dx + sign * dy) / 2, (dy - sign * dx) / 2, -1);
    }

    synchronized public void drawSlowly(Graphics2D g) {
        g.translate(0, HEIGHT - 1);  g.scale(1, -1);  // 1ݸ¤
        Plotter pt = new Plotter(g);
        pt.moveTo(100, 100);  draw(pt, order, 200, 0, 1);
    }

    public static void main(String[] args) {
        JFrame frame = new JFrame("ɥ饴󥫡");
        Dragon p1 = new Dragon(10);
        Dragon p2 = new Dragon(12);
        Container c = frame.getContentPane();

        Box b = new Box(BoxLayout.Y_AXIS);
        b.add(new JLabel("̿ = " + p1.getOrder()));
        b.add(p1);
        c.add(b, BorderLayout.WEST);

        b = new Box(BoxLayout.Y_AXIS);
        b.add(new JLabel("̿ = " + p2.getOrder()));
        b.add(p2);
        c.add(b, BorderLayout.EAST);

        frame.pack();               // Ŭڤ礭
        frame.setDefaultCloseOperation(frame.EXIT_ON_CLOSE);
        frame.setResizable(false);  // ѹԲ
        frame.setVisible(true);     // ɽ
        p1.start();
        p2.start();
    }
}
