/**
 *  DrawOneByOnePanel.java -- ༡Ū¸ѥͥ
 *
 *  @version $Revision: 1.13 $, $Date: 2003/03/19 09:08:34 $
 */

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;
import javax.swing.border.*;

public abstract class DrawOneByOnePanel extends JPanel
                                        implements Runnable {
    private int width, height, border;
    protected BufferedImage offScreen = null;
    protected volatile Thread thread = null;
    protected boolean threadSuspended = false;
    protected MouseAdapter mouseRestart;

    /** ΰ礭ʱʤ */
    public DrawOneByOnePanel(int width, int height) {
        this(width, height, -2);
    }

    /** ΰȼϤ;礭ʱꤢ */
    public DrawOneByOnePanel(int width, int height, int space) {
        this.width = width;  this.height = height;  border = space + 2;
        setBorder(new EtchedBorder());  // 2饤αĤ
        setPreferredSize(new Dimension(width  + border * 2,
                                       height + border * 2));
        mouseRestart = new MouseAdapter() {
                public void mouseClicked(MouseEvent e) {
                    if (thread == null) start();
                    else threadSuspended = !threadSuspended;
                }
            };
        addMouseListener(mouseRestart);
    }

    /** 賫 */
    public void start() {
        threadSuspended = false;
        thread = new Thread(this);  thread.start();  // run() ƤӽФ
    }

    /**  */
    public void stop() {  thread = null;  }

    public void run() {  // start() ̥åɤǸƤӽФ
        offScreen = new BufferedImage(width, height,
                                      BufferedImage.TYPE_INT_ARGB);
        Graphics2D g = offScreen.createGraphics();
        g.setColor(getForeground());
        g.setBackground(getBackground());
        g.clearRect(0, 0, width, height);
        drawSlowly(g);  repaint();  stop();
    }

    public void paint(Graphics g) {  // repaint() ƤӽФ
        if (border > 0) super.paint(g);
        if (offScreen != null)
            g.drawImage(offScreen, border, border, this);  // ²̤ɽ
    }

    /** Хåեsleep() ȤäƻĴ᤹*/
    abstract public void drawSlowly(Graphics2D g);  // ֥饹Ǽ

    private int wait = 0;  // Ԥ
    static final int WAIT_MIN = 100;

    /** ²̤ɽƻԤ */
    public boolean sleep() {  return sleep(WAIT_MIN);  }

    /** ²̤ɽƻԤѤ WAIT_MIN ߥðʾˤʤС*/
    public boolean sleep(int msec) {
        wait += msec;  if (wait < WAIT_MIN) return true;
        repaint();  // paint(g) ƤӽФ
        do {
            Thread t = Thread.currentThread();
            if (thread != t) return false;
            try {
                Thread.sleep(wait);
            } catch (InterruptedException e) {
                return false;
            }
        } while (threadSuspended);
        wait = 0;  return true;
    }
    //  http://java.sun.com/j2se/1.4/ja/docs/ja/guide/misc/threadPrimitiveDeprecation.html

    /** ѥͥҤȤĤΥե졼 */
    public void makeFrame(String title) {
        JFrame frame = new JFrame(title);
        frame.getContentPane().add(this);
        frame.pack();               // Ŭڤ礭
        frame.setDefaultCloseOperation(frame.EXIT_ON_CLOSE);
        frame.setResizable(false);  // ѹԲ
        frame.setVisible(true);     // ɽ
        start();
    }
}
