/*
* FFTMult.java -- FFT 軻
* @version $Revision: 1.7 $, $Date: 2003/01/26 05:45:34 $
* 10,000¿Ĺ¿饹 SInteger 
*/
import java.math.*;
import java.util.*;
import java.io.*;

/**
* FFT 軻ΥƥȡץǤ
* @see BDTools
* @see SInteger
*/

public class FFTMult {
    static final double EPS = 0.25;
    /**
    * SInteger a, b Ϳ a  b Ѥ֤ޤ
    * @see SInteger
    */
    public static SInteger getValue(SInteger a, SInteger b) {
        int N = SInteger.ceilpow2(Math.max(a.size, b.size)) * 2, i;
        FFT fftN = new FFT(N);
        double xr[] = new double[N];    // 0 ˽
        double xi[] = new double[N];
        double yr[] = new double[N];
        double yi[] = new double[N];
        double zr[] = new double[N];
        double zi[] = new double[N];

        for (i = 0; i < a.size ; i++) xr[i] = a.f[i];
        for (i = 0; i < b.size ; i++) yr[i] = b.f[i];
        fftN.fft(xr, xi);   fftN.fft(yr, yi);  // FFT
/* Ѥη׻
* Τ xr[], xi[] ˾񤭤뤳ȤǤ롣
* double xR = xr[i] * yr[i] - xi[i] * yi[i];
* double xI = xr[i] * yi[i] + xi[i] * yr[i];
* xr[i] = xR;   xi[i] = xI;
*/
        for (i = 0; i < N; i++) {
            zr[i] = xr[i] * yr[i] - xi[i] * yi[i];
            zi[i] = xr[i] * yi[i] + xi[i] * yr[i];
        }
        fftN.ifft(zr, zi);  // FFT

        SInteger r = new SInteger(N);
        //  Java  long η > double ͭפǤ뤳ȤȤäƤ롣
        // long  32 ӥåȤξ double Ȥɬפ롣
        for (i = 0; i < N - 1; i++) {
            long w = (long)(zr[i] + EPS); // double ͤ˴ݤ
            r.f[i] = (short)(w % SInteger.RADIX); // ;򤽤η˻Ĥ
            zr[i + 1] += w / SInteger.RADIX; // 夬
        }
        r.f[i] = (short)(zr[i] + EPS);  // Ǿ̤η
        return r;
    }
/**
*ƥȥץǤ<br>
*10,000Ǥη n ϤȡFFT 軻 BigInteger 軻η׻̤
*®٤ӤԤޤn = 10,000 ٤ˤ FFT 軻®Ȥ
*ʬޤ
* @see BITools
*/
    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));

        System.out.print(" = ");
        int fig = Integer.parseInt(in.readLine());  fig = SInteger.ceilpow2(fig);
        if (fig <= 0) {
            System.err.println("οͤϤƤ"); System.exit(-1);
        }
        SInteger siA = new SInteger(fig);
        SInteger siB = new SInteger(fig);
        SInteger siC = new SInteger(0);

        System.out.println( (fig * SInteger.FIGURES) + " ");
        siA.setRandom(fig);     siB.setRandom(fig);
        System.out.println("SInteger --> BigInteger Ѵ");

        BigInteger a = siA.toBigInteger();
        BigInteger b = siB.toBigInteger();

        System.out.println("\na = ");   BITools.print(a, 10);
        System.out.println("\nb = " + BITools.toDelimiterString(b, 10) + '\n');

        System.out.println("BigInteger 軻");
        long start = System.currentTimeMillis();
        BigInteger c = a.multiply(b); // c = a * b
        long tBD = System.currentTimeMillis() - start;
        System.out.println("result of a.multiply(b) =\n");
        BITools.print(c, SInteger.FIGURES);

        System.out.println("\nFFT 軻");
        start = System.currentTimeMillis();
        siC = getValue(siA, siB);
        long tFFT = System.currentTimeMillis() - start;
        System.out.println("result of getValue(a, b) =");    siC.print();

        System.out.println("SInteger --> BigInteger Ѵ");
        BigInteger d = siC.toBigInteger();
        int dig = BDTools.biFig10(d);

        d = d.subtract(c);  // d -= c
        System.out.println("c - d = " + d + " <== 0 ˤʤϤ");

        System.out.println("軻 10 ʤηγ : " + dig +
            "\n׻ BigInteger 軻 : " + tBD + "(ms)" + "  FFT 軻 : " + tFFT + "(ms)");
    }
}
