/*
* GaussSeidel.java -- Gauss ()--Seidel (ǥ) ˡ
* @version $Revision: 1.6 $, $Date: 2003/03/13 14:24:32 $
* class RVector Ȥ
*/
import java.io.*;

/**
* ϢΩ켡 Gauss-Seidel ˡǲ򤭤ޤ
*@see RMatrix
*@see NumberFormatter
*@see RVector
*@see GaussElimination
*@see Gauss3
*@see Gauss5
*/

public class GaussSeidel {
    /**
    *вϤʤʤ false ˤޤ
    */
    public static boolean verbose = true;
    static final double  EPS      = 1E-6; // Ƹ
    static final int     MAX_ITER = 500;  // 緫֤
    /**
    * ϢΩ켡 Ax = b  Gauss-Seidel ˡǲ򤭤ޤ
    *@param a A
    *@param b b
    *@param x 0˽Ƥޤ
    *@return  <code>true</code>« <code>false</code>
    */
    public static boolean solve(double[][] a, double[] x, double[] b) {
        int n = b.length;

        for (int iter = 1; iter <= MAX_ITER; iter++) {
            boolean ok = true;
            for (int i = 0; i < n; i++) {
                double s = b[i];
                for (int j = 0    ; j < i; j++) s -= a[i][j] * x[j];
                for (int j = i + 1; j < n; j++) s -= a[i][j] * x[j];
                s /= a[i][i];  // 餫гʬ1ˤƤ
                if (ok && Math.abs(x[i] - s) > EPS * (1 + Math.abs(s)))
                    ok = false;
                x[i] = s;  // SORˡʤ㤨 x[i] += 1.2 * (s - x[i]);
            }
            if (verbose) {
                System.out.println(iter + ":");
                RVector.print(x, 7, "11.6f");
            }
            if (ok) return true;  // 
        }
        return false;  // «
    }

    /**
    * ץǤ
    *<b>&quot;n = &quot;</b>ʹƤޤ 2 ʾͤϤƤ<br>
    *вɽǸɽϤ٤ 1.0 ˤʤޤ
    */

    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        System.out.print("n = ");
        int n = Integer.parseInt(in.readLine());
        double[][] a = new double[n][n];
        double[] x = new double[n], b = new double[n];

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) a[i][j] = 1;
            a[i][i] = 2;  b[i] = n + 1;  x[i] = 0;
        }
        if (solve(a, x, b) == false) System.out.println("«ޤ");
        System.out.println(" (Ϥ٤ 1)");
        RVector.print(x, 7, "11.6f");
    }
}
