/*
* GetCRC.java -- CRC
* @version $Revision: 1.9 $, $Date: 2003/03/30 15:08:08 $
*/
import java.io.*;
import java.text.*;
import java.util.*;
/**
* ե 32 ӥå CRC ˡ 2 ǵޤ
* CRCͤη׻ gzip  PNG եǻȤƤˡƱǤ
* @see CRC32t
*/

public class GetCRC {
    static final int CRCPOLY2  = 0xEDB88320;    // ž
    static final int BYTE_BIT  = 8;             // ХȤΥӥåȿ
    static final int TABLE_SIZE= 1 << BYTE_BIT; // = 256
    static final int BUFF_SIZE = 1024 * 32;     // = 32KB
    static byte[] buff = new byte[BUFF_SIZE];   // ɤ߹ߥХåե
    private static int[] crcTable = new int[TABLE_SIZE];

    static { // CRC32t.makeCrcTable2() Ʊơ֥
        for (int i = 0; i < TABLE_SIZE; i++) {
            int r = i;
            for (int j = 0; j < BYTE_BIT; j++)
                if ((r & 1) != 0) r = (r >>> 1) ^ CRCPOLY2;
                else              r >>>= 1;
            crcTable[i] = r;
        }
    }
    private static int evaluateCRC(int n, byte c[], int r) {
        int i = 0;

        while (--n >= 0)
            r = (r >> BYTE_BIT) ^ crcTable[(r ^ c[i++]) & 0xFF];

        return r;
    }
    /**
    * ե 32 ӥå CRC ޤ
    * @param fileName ե̾Ϳޤ
    */
    public static int ofFile(String fileName) throws IOException {
        BufferedInputStream in = null;
        try {
            in = new BufferedInputStream(new FileInputStream(fileName));
        } catch(FileNotFoundException e) {
            System.err.println("GetCRC : " + fileName + " Ĥޤ");
            System.exit(-1);
        }
        int crc = 0xffffffff, readSize;
        while ((readSize = in.read(buff)) > 0)
            crc = evaluateCRC(readSize, buff, crc);
        return crc ^ 0xffffffff;
    }
    private static class CrcInfo {
        static int  maxLenFN;   // ե̾Ĺκ
        static long maxSize;    // ե륵κ
        static long totalSize;  // ץ
        String fileName;        // ե̾
        int  crc;               // CRC 
        long size;              // ե륵
        boolean isFile;         // ե뤫
        CrcInfo() { // 
            maxSize = totalSize = maxLenFN = 0;
        }
        CrcInfo(String path) throws IOException {
            File file = new File(path);
            if ((isFile = file.isFile()) == false) return; // ǥ쥯ȥ

            fileName = file.getName();  // ե̾ΤߤФ
            crc  = ofFile(path);        // եѥ̾Ϥ
            size = file.length();
            int len = fileName.length();
            if (len > maxLenFN) maxLenFN = len;
            if (size > maxSize) maxSize = size;
            totalSize += size;
        }
        static Vector scanFiles(String[] path) throws IOException {
            Vector  vec = new Vector();
            CrcInfo cip = new CrcInfo(); // 

            for (int i = 0; i < path.length; i++) {
                cip = new CrcInfo(path[i]);
                if (cip.isFile) vec.add(cip);// ǥ쥯ȥϥå
            }
            return vec;
        }
    }
    // Ĺ w Ϣ³ʸʤ String 롣
    private static String makeConChar(int w, char c) {
        String s = "";
        while (w-- > 0) s += c;
        return s;
    }
    /* s θ ' '  w ʸ롣
    * "file name" ϤΤ˻ȤäƤ
    *  fileSpace Ȥä
    * String s = "file name";
    * s = s + fileSpace.substring(s.length());
    * ȤƤ褤ѤǤ뤫Τʤ᥽åɤ񤤤Ƥ
    */
    private static String stringW(String s, int w) {
        String space = makeConChar(w, ' ');
        return s + space.substring(s.getBytes().length);
    }
    /**
    * Ϳ줿ե 32 ӥå CRC ȥɸϤ˽Ϥޤ<br>
    * ϣ头Ȥ˥','Ƕڤޤ<br>
    * ˡjavac GetCRC file1 file2 ...<br>
    * 磻ɥɤȤޤξ硤Java λͤǥե̾ϼ˥Ȥޤ
    */
    public static void main(String[] args) throws IOException {
        if (args.length < 1) {
            System.err.println("ˡjava GetCRC file1 file2 ...");
            System.exit(-1);
        }

        Vector crcInfo = CrcInfo.scanFiles(args);
        if (crcInfo.size() == 0) {  // class Vector  size()
            System.err.println(args[0] + " ե뤬Ĥޤ");
            System.exit(-1);
        }

        CrcInfo crc = (CrcInfo)crcInfo.get(0);
        NumberFormat ifmt = NumberFormat.getNumberInstance();   // 3 ڤǽϤ format
        int sizeWidth = ifmt.format(crc.maxSize).length() + 2;  // file size ν
        if (sizeWidth < 5) sizeWidth = 5;
        int fnWidth   = crc.maxLenFN + 1;                       // file name ν
        if (fnWidth < 10) fnWidth = 10;
        String fileSpace = makeConChar(fnWidth, ' ');
        String sizeSpace = makeConChar(sizeWidth, ' ');

        System.out.println(stringW("file name", fnWidth) + "   CRC     size");
        System.out.println(makeConChar(fnWidth, '-') + " -------- " + makeConChar(sizeWidth, '-'));

        for (int i = 0; i < crcInfo.size(); i++) {
            crc = (CrcInfo)crcInfo.get(i);
//            String sFile = crc.fileName + fileSpace.substring(crc.fileName.length());
            //  ' ' ղácrc.fileName.length() Ǥѥե̾ξɽ֤롣
            String sFile = crc.fileName + fileSpace.substring(crc.fileName.getBytes().length);
            String sCrc  = Integer.toHexString(crc.crc).toUpperCase();
            sCrc = "00000000".substring(0, 8 - sCrc.length()) + sCrc;    // Ƭ 0 ղ
            String sSize = ifmt.format(crc.size);
            sSize = sizeSpace.substring(0, sizeWidth - sSize.length()) + sSize;

            System.out.println(sFile + " " + sCrc + " " + sSize);
        }
        System.out.println(makeConChar(fnWidth, '-') + " -------- " + makeConChar(sizeWidth, '-'));
        System.out.println(ifmt.format(crcInfo.size()) + " files   " +
            ifmt.format(crc.totalSize) + " bytes");
    }
}
