/**
 *  ϥåˡ
 *
 *  @version $Revision: 1.4 $, $Date: 2003/04/28 23:23:16 $
 */

import java.io.*;

public class HashAndTree {
    static final int HASH_SIZE = 101;  // ϥåɽ礭ǿ
    static final int CHAR_BIT = 8;  // 256ˡȤߤ

    class Node {           // 2ʬڤΥΡ
        Node left, right;  // λ
        String key;        // ʸ
    }

    Node zero, hashTable[];

    public HashAndTree() {
        zero = new Node();  // ֿ
        hashTable = new Node[HASH_SIZE];  // ϥåɽ
        for (int i = 0; i < HASH_SIZE; i++) hashTable[i] = zero;
    }

    private int hash(String s) {  // ñʥϥåؿ
        int v = 0;
        for (int i = 0; i < s.length(); i++)
            v = ((v << CHAR_BIT) + s.charAt(i)) % HASH_SIZE;
        return v;
    }

    boolean insert(String word) {  // Ͽ
        int cmp;  boolean isLeftChild = false;
        Node parent = null, child = hashTable[hash(word)];
        zero.key = word;  // ֿ
        while ((cmp = child.key.compareTo(word)) != 0) {
            parent = child;
            if (cmp < 0) { child = child.left;  isLeftChild = true; }
            else         { child = child.right; isLeftChild = false; }
        }
        if (child != zero) return false;  // ǤϿƤ
        Node q = new Node();
        q.key = word;  q.left = zero;  q.right = child;
        if (parent == null) hashTable[hash(word)] = q;
        else if (isLeftChild) parent.left  = q;
        else                  parent.right = q;
        return true;  // Ͽ
    }

    public static void main(String[] args) throws IOException {
        StreamTokenizer input =
            new StreamTokenizer(new InputStreamReader(System.in));

        HashAndTree tree = new HashAndTree();
        int words = 0,  newWords = 0;
        while (input.nextToken() != input.TT_EOF) {
            if (input.ttype != input.TT_WORD) continue;
            words++;
            if (tree.insert(input.sval.toLowerCase())) newWords++;
        }
        System.out.println(words + " words, "
                           + newWords + " different words");
    }
}
