/*
* Householder.java -- Householder (ϥۥ) Ѵ
* @version $Revision: 1.3 $, $Date: 2003/03/13 14:24:32 $
*/
import java.io.*;
import java.util.Random;

/**
* Householder (ϥۥ) ѴΥץǤ
*@see Tridiagonalize
*@see RVector
*/

public class Householder {
    /**
    * Householder ѴΥץǤ
    *@param x Ѵ٥ȥ
    *@return ѴΥ٥ȥκǽʬ
    */
    public static double transform(double[] x) {
        double s = Math.sqrt(RVector.innerProduct(x, x));  /* Ѥʿ, ʤ٥ȥ $x$ 礭 */

        if (s != 0) {
            if (x[0] < 0) s = -s;
            x[0] += s;  double t = 1 / Math.sqrt(x[0] * s);
            for (int i = 0; i < x.length; i++) x[i] *= t;
        }
        return -s;
    }

    /**
    * ȤäץǤ<br>
    *<b>&quot;n = &quot;</b>ʹƤޤ 2 ʾͤϤƤ<br>
    *ѴѴΥ٥ȥ( 1 ʬʳ 0)ʿѸϤޤ
    */

    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        System.out.print("n = ");
        int n = Integer.parseInt(in.readLine());
        double[] x = new double[n], v = new double[n];
        double s = 0;

        for (int i = 0; i < n; i++) {
            x[i] = v[i] = Math.random() - Math.random();
            s += x[i] * x[i];
        }
        System.out.println("x:");
        RVector.print(x, 7, "10.6f");
        System.out.println("||x|| = " + Math.sqrt(s));

        double x1 = transform(v);  /* HouseholderѴ */
        System.out.println("x' = (" + x1 + ", 0, ..., 0)");  /* ѴΥ٥ȥ */
        s = 0;  /* ʲϳǧ */
        for (int i = 0; i < n; i++) s += v[i] * x[i];
        for (int i = 0; i < n; i++) x[i] -= s * v[i];
        s = (x[0] - x1) * (x[0] - x1);
        for (int i = 1; i < n; i++) s += x[i] * x[i];
        System.out.println("ʿѸ: " + Math.sqrt(s / n));
    }
}
