/**
* KMP.java -- Knuth--Morris--Prattˡ
* @version $Revision: 1.3 $, $Date: 2002/12/16 01:03:25 $
*/

/**
*Knuth, Morris and Pratt ˤʸȹ祢르ꥺΥץǤ
*/

public class KMP {
    /**
    *text 椫 pattern Τ֤õޤ
    *@param text ʸ
    *@param pattern õʸ
    *@return pattern Τ֡Ƭ 0
    *pattern Ĺ丫Ĥʤ -1 
    *pattern Ĺ 0 ξ 0 ֤ޤ
    */
    public static int position(String text, String pattern) {
        int tLen = text.length(), pLen = pattern.length();
        if (pLen > tLen) return -1;  /* 顼: {\tt pattern}Ĺ */
        if (pLen == 0) return 0;
        int[] next = new int[pLen + 1];

        int i = 1, j = 0;  // next[1] = 0;
        while (i <  pLen) {
            if (pattern.charAt(i) == pattern.charAt(j)) {
                i++;  j++;  next[i] = j;
            } else if (j == 0) { i++;  next[i] = j; }
            else j = next[j];
        }
        /* ǥ󥹥ȥ졼 */
        for (int k = 0; k < pLen; k++)
            System.out.println("pattern[" + k + "] = " + pattern.charAt(k)
                    + ", next[" + (k+1) + "] = " + next[k+1]);
        /**************************/
        i = j = 0;
        while (i < tLen && j < pLen) {
            if (text.charAt(i) == pattern.charAt(j)) {  i++;  j++;  }
            else if (j == 0) i++;
            else j = next[j];
        }
        if (j == pLen) return i - j;
        return -1;  /* Ĥʤ */
    }
    /**
    * text = <b>&quot;supercalifragilisticexpialidocious&quot;</b>,
    * pattern = <b>&quot;ilisti&quot;</b> ξ
    *ץǤ
    *вɽޤ
    */

    public static void main(String[] args) {
        String text = "supercalifragilisticexpialidocious", pattern = "ilisti";
//      String text = "ABCABCABABC", pattern = "ABCABA";

        System.out.println("position(\"" + text + "\"" + ", \"" + pattern + "\") = " + position(text, pattern));
    }
}
