/**
 *  KochCurve.java -- Koch(å)
 *  (DrawOneByOnePanel.java, Plotter.java Ȥ)
 *
 *  @version $Revision: 1.9 $, $Date: 2003/03/18 10:05:54 $
 */

import java.awt.*;

public class KochCurve extends DrawOneByOnePanel {
    static final double D_MAX = 5; // ȰդĹûʤ롣
    static final int WIDTH = 600,  HEIGHT = 200;
    static final double[] COS = new double[6], SIN = new double[6];

    public KochCurve() {
        super(WIDTH + 1, HEIGHT + 1, 3);
        for (int i = 0; i < 6; i++) {
            COS[i] = Math.cos(i * Math.PI / 3);
            SIN[i] = Math.sin(i * Math.PI / 3);
        }
    }

    private void draw(Plotter pt, int a, double d) {
        if (d <= D_MAX) {
            pt.drawRelative(d * COS[a % 6], d * SIN[a % 6]);
            sleep((int)D_MAX);  // ɽԤ
            return;
        }
        d /= 3;  draw(pt, a, d);  a++;  draw(pt, a, d);
        a += 4;  draw(pt, a, d);  a++;  draw(pt, a, d);
    }

    synchronized public void drawSlowly(Graphics2D g) {
        g.translate(0, HEIGHT);  g.scale(1, -1);  // 1ݸ¤
        Plotter pt = new Plotter(g);
        pt.moveTo(0, 0);  draw(pt, 0, WIDTH);
    }

    public static void main(String[] args) {
        DrawOneByOnePanel p = new KochCurve();
        p.makeFrame("Koch(å)");
    }
}
