/**
 *  LU ʬڤӤȤäϢΩ򤯥롼
 *
 *  @version $Revision: 1.5 $, $Date: 2003/03/13 14:24:33 $
 */
public class LU {
    private LU() {}
    /**
     *   a  LU ʬ򤹤롣<br>
     *  ʬԥܥåԤºݤ˹Ԥ򴹤ΤǤϤʤ
     *  Ԥֹ򴹤ξ ivec 롣
     *   ivec ϸФ solve() ȤäƼºݤϢΩ򤯺ݤ
     *  ɬפˤʤΤǤ롣
     *
     *  @param  a   LU ʬ򤹤(ʬη̤Ǿ񤭤)
     *  @param  ivec    Ԥθ򴹾Ǽ
     *  @return a ι󼰡줬 0 ʤ LU ʬǤʤȤ̣롣
     *  @see    #solve
     */
    public static double lu(double[][] a, int[] ivec) {
        int n = a.length;
        double[] weight = new double[n];
        for (int k = 0; k < n; k++) {   //  ƹԤˤĤ
            ivec[k] = k;    //  Ը򴹾ν
            double u = 0;   //  ιԤͺǤ
            for (int j = 0; j < n; j++) {
                double t = Math.abs(a[k][j]); if (t > u) u = t;
            }
            if (u == 0) return 0;   //  0 ʤ LU ʬǤʤ
            weight[k] = 1 / u;      //  ͤεտ
        }
        double det = 1;     //  󼰤ν
        for (int k = 0, m = n; k < n; k++) {    //  ƹԤˤĤ
            double u = -1;
            for (int i = k; i < n; i++) {   //  겼γƹԤˤĤ
                int ii = ivec[i];   //  Ťߡ ιԤ򸫤Ĥ
                double t = Math.abs(a[ii][k]) * weight[ii];
                if (t > u) { u = t; m = i; }
            }
            int ik = ivec[m];
            if (m != k) {
                ivec[m] = ivec[k]; ivec[k] = ik;    //  ֹ
                det = -det;     //  Ԥ򴹤й󼰤椬Ѥ
            }
            u = a[ik][k]; det *= u;  //  гʬ
            if (u == 0) return 0;   //  0 ʤ LU ʬǤʤ
            for (int i = k + 1; i < n; i++) {   //  Gauss õˡ
                int ii = ivec[i];
                a[ii][k] /= u;
                double t = a[ii][k];
                for (int j = k + 1; j < n; j++)
                    a[ii][j] -= t * a[ik][j];
            }
        }
        return det;     //  ͤϹ
    }
    /**
     *  lu()  LU ʬ򤷤 a ȤäϢΩ a x = b 򤯡
     *
     *  @param  a   LU ʬѤߤι
     *  @param  b   ϢΩα
     *  @param  ivec    Ԥθ򴹾󤬳Ǽ줿
     *  @param  x   Ǽ٥ȥ
     *  @see    #lu
     */
    public static void solve(double[][] a, double[] b,
                             int[] ivec, double[] x) {
        int n = a.length;
        for (int i = 0; i < n; i++) {
            int ii = ivec[i]; double t = b[ii];
            for (int j = 0; j < i; j++) t -= a[ii][j] * x[j];
            x[i] = t;
        }
        for (int i = n - 1; i >= 0; i--) {
            double t = x[i]; int ii = ivec[i];
            for (int j = i + 1; j < n; j++) t -= a[ii][j] * x[j];
            x[i] = t / a[ii][i];
        }
    }
    /**
     *  lu(), solve() ˸ƤӽФϢΩ a x = b 򤯡<br>
     *  ϢΩȤʤ餳ȤФ褤Ȥ⤢ʤ
     *  ǽˣ lu() ƤӽФȤ solve() ɬפʤ
     *  ƤӽФ®
     *
     *  @param  a   ϢΩη
     *  @param  b   ϢΩα
     *  @param  x   Ǽ٥ȥ
     *  @return a ι󼰡줬 0 ʤϢΩ(ޤʤ)
     *          ޤǽ(¸ߤʤ)
     *  @see    #lu
     *  @see    #solve
     */
    public static double gauss(double[][] a, double[] b, double[] x) {
        int n = a.length; int[] ivec = new int[n];
        double det = lu(a, ivec);
        if (det != 0) solve(a, b, ivec, x);
        return det;
    }
}

