/*
* LUDecomposition.java -- LUʬ
* @version $Revision: 1.7 $, $Date: 2003/03/13 14:24:33 $
* main()  class RMatrix, RVector, NumberFormatter Ȥ
* mathutils.LU.java; ȤۤƱ
*/
import java.io.*;

/**
*LUʬϢΩ򤭤ޤ
*@see RMatrix
*@see RVector
*@see NumberFormatter
*/
public class LUDecomposition {
    static double lu(double[][] a, int[] ip) {
        int n = a.length;
        double[] weight = new double[n];    // weight[0..n-1] εΰ

        for (int k = 0; k < n; k++) {   // ƹԤˤĤ
            ip[k] = k;                  // Ը򴹾ν
            double u = 0;               // ιԤͺǤ
            for (int j = 0; j < n; j++) {
                double t = Math.abs(a[k][j]);  if (t > u) u = t;
            }
            if (u == 0) return 0;   // 0 ʤLUʬǤʤ
            weight[k] = 1 / u;      // ͤεտ
        }
        double det = 1;                 // 󼰤ν
        for (int k = 0; k < n; k++) {   // ƹԤˤĤ
            double u = -1;
            int m = 0;
            for (int i = k; i < n; i++) {// 겼γƹԤˤĤ
                int ii = ip[i];          // Ťߡ ιԤ򸫤Ĥ
                double t = Math.abs(a[ii][k]) * weight[ii];
                if (t > u) {  u = t;  m = i;  } //  u = -1 && t >= 0 Ǥ뤫{}ɬ¹Ԥ롣
            }
            int ik = ip[m];
            if (m != k) {
                ip[m] = ip[k];  ip[k] = ik; // ֹ
                det = -det;  // Ԥ򴹤й󼰤椬Ѥ
            }
            u = a[ik][k];  det *= u;    // гʬ
            if (u == 0) return 0;       // 0 ʤLUʬǤʤ
            for (int i = k + 1; i < n; i++) {// Gaussõˡ
                int ii = ip[i];  double t = (a[ii][k] /= u);
                for (int j = k + 1; j < n; j++) a[ii][j] -= t * a[ik][j];
            }
        }
        return det;           // ͤϹ
    }
    /**
    *LUʬη̤ȤäϢΩ Ax = b 򤭤ޤ
    *դۤʤʣϢΩ򤯤ΤǤ
    *@param a LUʬ򤷤
    *@param b 
    *@param x 
    *@param ip <code>lu()</code>ιԸ򴹾
    */

    public static void solve(double[][] a, double[] b, int[] ip, double[] x) {
        int n = a.length;

        for (int i = 0; i < n; i++) {   // GaussõˡλĤ
            int ii = ip[i];  double t = b[ii];
            for (int j = 0; j < i; j++) t -= a[ii][j] * x[j];
            x[i] = t;
        }
        for (int i = n - 1; i >= 0; i--) { // 
            double t = x[i];  int ii = ip[i];
            for (int j = i + 1; j < n; j++) t -= a[ii][j] * x[j];
            x[i] = t / a[ii][i];
        }
    }
    /**
    *LUʬη̤ȤäϢΩ򤭤ޤ
    *@param a 
    *@param b 
    *@param x 
    *@return 
    */
    public static double gauss(double[][] a, double[] b, double[] x) {
        int   n    = a.length;
        int[] ip   = new int[n]; // Ը򴹤ξ
        double det = lu(a, ip);  // LUʬ򤷤ƹ󼰤

        if (det != 0) solve(a, b, ip, x);  // LUʬη̤ȤäϢΩ
        return det;                        // ͤϹ
    }

    /**
    * ȤäץǤ<br>
    *<strong>&quot;μ n = &quot;</strong>ʹƤޤ2ʾ
    *ͤϤƤ<br>
    *󼰤ͤӲ, ȤξդκϤޤ
    */
    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        System.out.print("μ n = ");
        int n = Integer.parseInt(in.readLine());    // μ
        double[][] a = new double[n][n], aSave = new double[n][n];
        double[]   b = new double[n],    bSave = new double[n],
                   x = new double[n];

        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                a[i][j] = aSave[i][j] = Math.random() - Math.random();

        System.out.println("");
        RMatrix.print(a, 10, "7.3f");
        for (int i = 0; i < n; i++)
            b[i] = bSave[i] = Math.random() - Math.random();
        System.out.println("");
        RVector.print(b, 10, "7.3f");

        double det = gauss(a, b, x);  // Gaussˡ $Ax=b$ 
        System.out.println(" = " + det);
        System.out.println(", Ȥξդκ");

        NumberFormatter fmtf = new NumberFormatter("16.7f"),
                        fmte = new NumberFormatter("16.7e"),
                        fmtd = new NumberFormatter("2d");
        for (int i = 0; i < n; i++) {
            double s = bSave[i];
            for (int j = 0; j < n; j++) s -= aSave[i][j] * x[j];
            System.out.println(fmtd.toString(i) + ":" + fmtf.toString(x[i]) +
                fmte.toString(s));
        }
    }
}
