/**
 * Newton1Test.java -- Newtonˡ(Newton1)λ
 * @version $Revision: 1.4 $, $Date: 2003/04/05 15:10:00 $
 */

import java.io.*;
import java.util.*;

/**
 * Newtonˡ(Newton1)λǤ<br>
 * ؿ <code>f(x) = x<sup>3</sup> - 2x + 3</code>
 * Ƴؿ <code>f'(x) = 3x<sup>2</sup> - 2</code>
 * ͿƤޤ<br>
 * @see Newton1
 */
public class Newton1Test {
    /** f(x) = x^3 + bx^2 + c^x + d */
    static class CubicFunction implements Newton1.Function {
        private double b, c, d;
        public CubicFunction(double a, double b, double c, double d) {
            this(b / a, c / a, d / a);
        }
        public CubicFunction(double b, double c, double d) {
            this.b = b;  this.c = c;  this.d = d;
        }
        public double of(double x) { // ᤿ؿ $f(x)$
            return ((b + x) * x + c) * x + d;
        }
        public double primeOf(double x) { // $f(x)$ Ƴؿ
            return (2 * b + 3 * x) * x + c;
        }
    }

    /**
     * ǫʾʬ򤷤ơ<br>
     * <code>x<sup>3</sup> + bx<sup>2</sup> + cx + d = 0</code><br>
     * 򤭡μ¿ɽޤ
     */
    // ʸٻFACOMޥ˥奢SSL II Ѽ
    public static void solveCubicEq(double a, double b, double c, double d) {
        b /= a;  c /= a;  d /= a;
        a = b * b - 3 * c;
        CubicFunction cf = new CubicFunction(b, c, d);

        if (a > 0) {
            double minP = (-b + Math.sqrt(a))/3.0;  // ˾κɸ
            double maxP = (-b - Math.sqrt(a))/3.0;  // κɸ
            double minF = cf.of(minP);              // ˾
            double maxF = cf.of(maxP);              // 
            a = (2.0 / 3.0) * Math.sqrt(a);
            if (minF * maxF < 0) { // 3Ĥβľ
                double x1 = Newton1.solve(cf, -a - b / 3);  // ¦
                System.out.println("x1 = " + x1);
                double x2 = Newton1.solve(cf, a - b / 3);   // ¦
                System.out.println("x2 = " + x2);
                double x3 = Newton1.solve(cf, b / (-3));    // Ѷ
                System.out.println("x3 = " + x3);
            } else { // 1ĤŲ
                double x0;
                if (maxF > 0) x0 = -a - b / 3;  // ¦
                else          x0 =  a - b / 3;  // ¦
                double x1 = Newton1.solve(cf, x0);
                System.out.println("x1 = " + x1);
                if (minF == 0) System.out.println("x2 = " + minP + " (Ų)");
                if (maxF == 0) System.out.println("x2 = " + maxP + " (Ų)");
            }
        } else if (a < 0) { // f'(x) = 0 ²ʤ
            double x1 = Newton1.solve(cf, b / (-3));    // Ѷ
            System.out.println("x = " + x1);
        } else { // f'(x) = 0 Ųľ
            double x0 = b / (-3); // Ѷ
            x0 = x0 - cf.of(x0);  // ༡ˡ1Ŭ
            double x1 = Newton1.solve(cf, x0);
            System.out.println("x1 = " + x1 + " (Ų)");
        }
    }

    /**
     *  a, b, c, d ǶڤäϤȣ<br>
     * <code>ax<sup>3</sup> + bx<sup>2</sup> + cx + d = 0</code><br>
     * μ¿ɽޤ
     * @see Cardano
     */
    public static void main(String[] args) throws IOException {
        System.out.println("ax^3+bx^2+cx+d=0򤭤ޤ.");
        System.out.println("a b c d ? ");
        BufferedReader in =
            new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer st = new StringTokenizer(in.readLine());
        double a = Double.parseDouble(st.nextToken()),
               b = Double.parseDouble(st.nextToken()),
               c = Double.parseDouble(st.nextToken()),
               d = Double.parseDouble(st.nextToken());
        if (a == 0) {
            System.out.println("3ǤϤޤ");  System.exit(-1);
        }

        System.out.println("Cardano()θ");
        Cardano.solve(a, b, c, d);
        System.out.println();

        System.out.println("solveCubicEq()");
        solveCubicEq(a, b, c, d);
        System.out.println();

        System.out.println("Newton1 ");
        b /= a;  c /= a;  d /= a;
        a = b * b - 3 * c;
        CubicFunction cf = new CubicFunction(b, c, d);
        if (a > 0) {
            double mp = (-b + Math.sqrt(a))/3.0;    // ˾κɸ
            a = (2.0 / 3.0) * Math.sqrt(a);
            double x1 = Newton1.solve(cf, -a - b / 3);  // ¦顤˾ëϤ뤳ȤǤ
            System.out.println("x1 = " + x1);
            if (cf.of(mp) > 0) System.exit(0);      // ˾ͤ :Ƚ꤬ʤ 2 5 2 6 ʤɤǼ«ʤ
            double x2 = Newton1.solve(cf, a - b / 3);   // ¦
            if (x2 == x1) System.exit(0);
            System.out.println("x2 = " + x2);
            double x3 = Newton1.solve(cf, b / (-3));    // Ѷ
            System.out.println("x3 = " + x3);
        } else {
            double x1 = Newton1.solve(cf, 0);           // Ŭ
            System.out.println("x = " + x1);
        }
    }
}
