/**
 *  Newton2.java -- Newton (˥塼ȥ) ˡ
 *
 *  @version $Revision: 1.10 $, $Date: 2003/04/05 15:10:00 $
 */

import java.io.*;
import java.text.DecimalFormat;

/**
 *  <code><i>f</i>(<i>x</i>) = 0</code> β
 * Newton (˥塼ȥ) ˡȤäƵޤ<br>
 * Ƴؿ <code><i>f</i> '(<i>x</i>)</code> פǤ
 * @see Newton1
 */
public class Newton2 {
    /** ᤿ؿ f(x) */
    public interface Function {  public double of(double x);  }

    static final double EPS = 1.0e-14; // «Ƚ˻Ȥ
    static final DecimalFormat DF2  = new DecimalFormat(" 0.0E00;-0.0E00");
    static final DecimalFormat DF15 = new
        DecimalFormat(" 0.000000000000000E00;-0.000000000000000E00");

    /**
     *  $x$  $f(x) = 0$ β<br>
     * «ͻҤɽޤ
     * @param x ͤͿޤ
     * @return  <code><i>f</i>(<i>x</i>) = 0</code> β֤ޤ
     */
    public static double solve(Function f, double x) { // 
        double fx = f.of(x);
        while (fx != 0) {
            double df = f.of(x + fx) - fx, h = fx * fx / df,
                   xPrev = x, fxPrev = fx;
            int i = 0;

            do {
                x = xPrev - h;  fx = f.of(x);  h /= 2;  i++;
                System.out.println("(" + i + ") x = " + DF15.format(x)
                                   + "  f(x) = " + DF2.format(fx));
            } while (Math.abs(fx) > Math.abs(fxPrev));
            if (i == 1 && Math.abs(x - xPrev) < EPS) break;
        }
        return x;
    }

    /**
     * ͤϤơ <code>arctan(<i>x</i> - 1) = 0</code>
     * β륵ץ롦ץǤ
     */
    public static void main(String[] args) throws IOException {
        BufferedReader input =
            new BufferedReader(new InputStreamReader(System.in));

        System.out.println("atan(x - 1) = 0 򤭤ޤ.");
        System.out.print(" = ");
        double x = Double.parseDouble(input.readLine());
        Newton2.Function f =  new Newton2.Function() {
                public double of(double x) { // ᤿ؿ f(x)
                    return Math.atan(x - 1);
                }
            };
        x = Newton2.solve(f, x);
        System.out.println(" " + x + "Ǥ.");
    }
}
