/**
* PowerEigen.java -- ߾ˡ
* @version $Revision: 1.1 $, $Date: 2003/03/20 03:05:52 $
*/
import java.util.*;     // Arrays
import java.io.*;

/**
*߾ˡˤθͭͭ͡٥ȥץǤ
*@see JacobiMethod
*@see Tridiagonalize
*@see QRAlgorithm
*@see RVector
*@see RMatrix
*/

public class PowerEigen {
    static final double EPS    = 1E-6;  /* ͭ٥ȥεƸ */
    static final int  MAX_ITER =  200;  /* 緫֤ */
    /**
    *<code>a[0..n-1][0..n-1]</code>äоι A 顤mĤθͭͤȸͭ٥ȥ߾ˡǵޤ<br>
    *<code>lambda[k]</code>˸ͭͤбͭ٥ȥ <code>x[k][0..n-1]</code> ޤ
    *@return «ͭ٥ȥο
    */
    public static int solve(int m, double[][] a, double[] lambda, double[][] x) {
        int n = a.length;
        int kk = m;             /* ºݤ˵줿ͭͭ͡٥ȥθĿ */
        double[] y = new double[n];

        for (int k = 0; k < m; k++) { /* \texttt{k} ܤθͭͭ͡٥ȥ */
            int iter = 0;
            double d = 0, d1, e, s = 0, s1, xk[] = x[k];

            Arrays.fill(xk, 1 / Math.sqrt(n));   /* 礭1νͥ٥ȥ */
            do {
                d1 = d;  s1 = s;  s = e = 0;
                for (int i = 0; i < n; i++) {
                    double t = 0;
                    for (int j = 0; j < n; j++) t += a[i][j] * xk[j];
                    y[i] = t;  s += t * t;  /* $y = Ax$ */
                }
                s = Math.sqrt(s);  if (s1 < 0) s = -s;  /* $s = \pm \| y \|$ */
                for (int i = 0; i < n; i++) {
                    double t = y[i] / s, u = xk[i] - t;
                    e += u * u;  xk[i] = t;  /* \texttt{xk[]}: ͭ٥ȥ */
                }
                if (e > 2) s = -s;  /* ٥ȥ뤬ȿžʤͭͤ */
                d = Math.sqrt(e);  d1 -= d;
// ƥ///
                NumberFormatter fmt   = new NumberFormatter("12.8f");
                NumberFormatter fmt3d = new NumberFormatter("3d");
                System.out.println("iter = " + fmt3d.toString(iter) + " lambda[" + k + "]=" + fmt.toString(s) + " "
                    + "||x' - x|| = " + fmt.toString(e));
/////////////
            } while (++iter < MAX_ITER && e > EPS * d1);
            if (iter >= MAX_ITER && kk == m) kk = k;
            lambda[k] = s;  /* ͭ */
            if (k < m - 1)
                for (int i = 0; i < n; i++)
                    for (int j = 0; j < n; j++)
                        a[i][j] -= s * xk[i] * xk[j];
        }
        return kk;  /* «ͭ٥ȥο */
    }
// ƥ main()
    /**
    * ȤäץǤ<br>
    *<b>&quot;n = &quot;</b>ʹƤޤ2ʾ()ϤƤ<br>
    *ι A«ͻҡ«ͭ٥ȥοͭ͡ʿѸͭ٥ȥľ
    *Ϥޤ
    */
    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        System.out.print("n = ");
        int n = Integer.parseInt(in.readLine());
        double[][]  a   = new double[n][n],
                    b   = new double[n][n],
                    x   = new double[n][n];
        double[] lambda = new double[n];

        for (int i = 0; i < n ; i++)
            for (int j = 0; j <= i; j++)
                a[i][j] = a[j][i] =
                b[i][j] = b[j][i] = Math.random() - Math.random();
        RMatrix.print(a, 5, "14.8f");
        int m = solve(n, a, lambda, x);

        double s, e = 0;
        for (int i = 0; i < n ; i++)
            for (int j = 0; j < n; j++) {
                s = b[i][j];
                for (int k = 0; k < n ; k++)
                    s -= lambda[k] * x[k][i] * x[k][j];
            e += s * s;
        }

        NumberFormatter fmt   = new NumberFormatter("14.5e");
        System.out.println("\nͭ٥ȥľγǧ");
        for (int i = 0; i < n; i++)
            for (int j = i + 1; j < n; j++)
                System.out.println("x[" + i + "]x[" + j + "] = "
                    + fmt.toString(RVector.innerProduct(x[i], x[j])));

        System.out.println("«ͭ٥ȥο: " + m);
        System.out.println("ͭ:");
        RVector.print(lambda, 5, "14.8f");
        System.out.println("ʿѸ: " + fmt.toString(Math.sqrt(e / (n * n))));
    }
}
