/**
 *  󥯥饹
 *
 *  double ΣˤФƼ黻᥽åɤ󶡤ޤ
 *
 *  @version $Revision: 1.7 $, $Date: 2003/10/30 19:53:06 $
 */
public class RMatrix {
    /**
     *   i ܤιԤ j ܤιԤ򴹤
     *  @param  i, j    ֹ(0,1,..)
     */
    public static void swapRow(double[][] mtx, int i, int j) {
        double[] temp = mtx[i]; mtx[i] = mtx[j]; mtx[j] = temp;
    }
    /**
     *   i ܤ j ܤ򴹤
     *  @param  i, j    ֹ(0,1,..)
     */
    public static void swapCol(double[][] mtx, int i, int j) {
        for (int k = 0; k < mtx.length; k++) {
            double temp = mtx[k][i]; mtx[k][i] = mtx[k][j]; mtx[k][j] = temp;
        }
    }
    /**
     *  žֹ֤ޤ
     *  @return mtx<sup>T</sup>
     */
    public static double[][] transpose(double[][] mtx) {
        int n = mtx.length, m = mtx[0].length;
        double[][] ret = new double[m][n];
        for (int i = 0; i < n; i++) for (int j = 0; j < m; j++)
            ret[j][i] = mtx[i][j];
        return ret;
    }
    /**
     *  ͤ (lhs + rhs) Ȥʤ֤ޤ
     *  @param  lhs 
     *  @param  rhs 
     *  @return (lhs + rhs)
     */
    public static double[][] add(double[][] lhs, double[][] rhs) {
        int n = lhs.length, m = lhs[0].length;
        if (n != rhs.length || m != rhs[0].length)
            throw new IndexOutOfBoundsException();
        double[][] ret = new double[n][m];
        for (int i = 0; i < n; i++) for (int j = 0; j < m; j++)
            ret[i][j] = lhs[i][j] + rhs[i][j];
        return ret;
    }
    /**
     *  ͤ (lhs - rhs) Ȥʤ֤ޤ
     *  @param  lhs 
     *  @param  rhs 
     *  @return (lhs - rhs)
     */
    public static double[][] subtract(double[][] lhs, double[][] rhs) {
        int n = lhs.length, m = lhs[0].length;
        if (n != rhs.length || m != rhs[0].length)
            throw new IndexOutOfBoundsException();
        double[][] ret = new double[n][m];
        for (int i = 0; i < n; i++) for (int j = 0; j < m; j++)
            ret[i][j] = lhs[i][j] - rhs[i][j];
        return ret;
    }
    /**
     *  ͤ (a * mtx) Ȥʤ֤ޤ
     *  @param  a   ˤ
     *  @param  mtx 
     *  @return (a * mtx)
     */
    public static double[][] multiply(double a, double[][] mtx) {
        int n = mtx.length, m = mtx[0].length;
        double[][] ret = new double[n][m];
        for (int i = 0; i < n; i++) for (int j = 0; j < m; j++)
            ret[i][j] = a * mtx[i][j];
        return ret;
    }
    /**
     *  ͤ (lhs * rhs) Ȥʤ֤ޤ
     *  @param  lhs 
     *  @param  rhs 
     *  @return (lhs * rhs)
     */
    public static double[][] multiply(double[][] lhs, double[][] rhs) {
        int n = lhs.length, m = rhs[0].length, l = lhs[0].length;
        if (l != rhs.length) throw new IndexOutOfBoundsException();
        double[][] ret = new double[n][m];
        for (int i = 0; i < n; i++) for (int j = 0; j < m; j++) {
            double value = 0.0;
            for (int k = 0; k < l; k++) value += lhs[i][k] * rhs[k][j];
            ret[i][j] = value;
        }
        return ret;
    }
    /**
     *  ͤ (mtx * v) Ȥʤ٥ȥ֤ޤ
     *  @param  mtx 
     *  @param  v   ٥ȥ
     *  @return (mtx * v)
     */
    public static double[] multiply(double[][] mtx, double[] v) {
        int n = mtx.length, m = mtx[0].length;
        if (m != v.length) throw new IndexOutOfBoundsException();
        double[] ret = new double[n];
        for (int i = 0; i < n; i++) {
            double value = 0.0;
            for(int j = 0; j < m; j++) value += mtx[i][j] * v[j];
            ret[i] = value;
        }
        return ret;
    }
    /**
     *  ͤ (v * mtx) Ȥʤ٥ȥ֤ޤ
     *  @param  v   ٥ȥ
     *  @param  mtx 
     *  @return (v * mtx)
     */
    public static double[] multiply(double[] v, double[][] mtx) {
        int n = mtx.length, m = mtx[0].length;
        if (n != v.length) throw new IndexOutOfBoundsException();
        double[] ret = new double[m];
        for (int i = 0; i < m; i++) {
            double value = 0.0;
            for(int j = 0; j < n; j++) value += v[j] * mtx[j][i];
            ret[i] = value;
        }
        return ret;
    }
    /**
     *  ƤʸǽϤޤ
     *  @param  mtx 
     *  @return "[[mtx[0][0], mtx[0][1], ...], [mtx[1][0], ...], ...]"
     *          ʸ
     */
    public static String toString(double[][] mtx) {
        int n = mtx.length, m = mtx[0].length;
        String str = "[";
        for (int i = 0; i < n; i++) {
            str += "[";
            for (int j = 0; j < m; j++) {
                str += mtx[i][j];
                if (j < m - 1) str += ", ";
            }
            str += "]";
            if (i < n - 1) str += ", ";
        }
        str += "]";
        return str;
    }
/***************** ʲϰ᥽å ***************************************/
    /**
     *  Ǥޤ
     *  @see NumberFormatter
     *  @param  perLine 1Ԥ˰ǿ
     *  @param  format  NumberFormatter Ϳ
     */
    public static void print(double[][] a, int perLine, String format) {
    // a[m][n] ΤȤa.length = m, a[0].length = n ˤʤ롣
        print(a, a.length, a[0].length, perLine, format);
    }

    /**
     *  κ¦ nCol ޤ
     *  @see NumberFormatter
     *  @param  nCol ο
     *  @param  perLine 1Ԥ˰ǿ
     *  @param  format  NumberFormatter Ϳ
     */
    public static void print(double[][] a, int nCol, int perLine, String format) {
        print(a, a.length, nCol, perLine, format);
    }

    /**
     *  κ1Ԥ nRow ԡ1󤫤 nCol ʬޤ
     *  @see NumberFormatter
     *  @param  nRow Ԥο
     *  @param  nCol ο
     *  @param  perLine 1Ԥ˰ǿ
     *  @param  format  NumberFormatter Ϳ
     */
    public static void print(double[][] a, int nRow, int nCol, int perLine, String format) {
        for (int i = 0; i < nRow; i++) {
            RVector.print(0, nCol, a[i], perLine, format);
            if (nCol > perLine) System.out.println();
        }
    }
/*****************************************************************************/

    /**
     *  ͣΥȥݥ
     *  @param  args    --
     */
    public static void main(String[] args) {
        double[][]  m1 = new double[2][2];
        m1[0][0] = 1.0; m1[0][1] = 1.0; m1[1][0] = 1.0; m1[1][1] = 1.0;
        double[][]  m2 = (double[][])m1.clone();
        double[][]  m3 = add(m1,m2), m4 = multiply(m2,m3),
                    m5 = subtract(m3,m4);
        System.out.println(toString(m3) + "\n"
                         + toString(m4) + "\n"
                         + toString(m5));
    }

}

