/*
 *  RSA Υץ
 *  DES ̩ RSA ȤäưŹ沽
 */
import java.io.*;
import java.math.BigInteger;
import java.util.Random;

import java.security.Key;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.SecureRandom;

import java.security.interfaces.RSAPublicKey;
import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPrivateCrtKey;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;

public class RSA {
    RSAPrivateKey privateKey;   // Alice ̩
    RSAPublicKey publicKey;     // Alice θ

    public RSA() throws Exception {
        // RSA Ѹ
        KeyPairGenerator keyPairGen = KeyPairGenerator.getInstance("RSA");
        // 르ꥺ
        SecureRandom random = SecureRandom.getInstance("SHA1PRNG");
        // μ
        random.setSeed("Alice 090-1234-5678".getBytes());
        // 1024 bit θ
        keyPairGen.initialize(1024, random);
        KeyPair keyPair = keyPairGen.genKeyPair();
        privateKey = (RSAPrivateKey)keyPair.getPrivate();
        publicKey = (RSAPublicKey)keyPair.getPublic();
        verify(privateKey, publicKey);
    }

    void verify(RSAPrivateKey priv, RSAPublicKey pub) {
        // ǧΤn=pq  ed = 1 mod (n), (n) = (p-1)(q-1) å
        System.out.println("verify RSA parameter------");
        RSAPrivateCrtKey crt = (RSAPrivateCrtKey)priv;
        BigInteger p = crt.getPrimeP(), q = crt.getPrimeQ();
        System.out.println("p=" + p + "\nq=" + q);
        System.out.println("n=" + priv.getModulus());
        BigInteger n = p.multiply(q);
        System.out.println("pq is equal to n:" + n.equals(priv.getModulus()));
        BigInteger phi_n = p.subtract(BigInteger.ONE);
        phi_n = phi_n.multiply(q.subtract(BigInteger.ONE));
        BigInteger e = priv.getPrivateExponent();
        BigInteger d = pub.getPublicExponent();
        System.out.println("e=" + e + "\nd=" + d);
        System.out.println("ed mod (p-1)(q-1)=" + e.multiply(d).mod(phi_n));
        System.out.println("--------------------------");
    }

    // DES ˤŹ沽
    static public void useDES(int mode, Key key, InputStream in,
                              OutputStream out) throws Exception {
        Cipher cipher = Cipher.getInstance("DES");
        cipher.init(mode, key);
        byte[] data = new byte[1024];
        int len;
        while ((len = in.read(data)) != -1) {
            out.write(cipher.update(data, 0, len));
        }
        byte[] bytes = cipher.doFinal();
        if (bytes != null) out.write(bytes);
        out.flush();
    }

    public static void main(String args[]) throws Exception {
        // DES 
        SecretKeyFactory keyFactory
                = SecretKeyFactory.getInstance("DES");

        // Alice  RSA θ publicKey Τߤ
        RSA test = new RSA();
        RSAPublicKey pub = test.publicKey;

        // Bob  Alice ˰Źʸ -------------------------
        // Bob Ŭʿ(secretNum)
        System.out.println("Bob ¦");
        Random rand = new Random(1234);
        BigInteger secretNum = new BigInteger(100, rand);
        System.out.println("secretNum =" + secretNum);

        // 򸵤 DES θ(Ƭ8byteΤߤѤ)
        DESKeySpec keySpec = new DESKeySpec(secretNum.toByteArray());
        SecretKey secretKey = keyFactory.generateSecret(keySpec);

        FileInputStream in = new FileInputStream("RSA.java");
        FileOutputStream out = new FileOutputStream("RSA.java.encoded");

        // DES ǰŹ沽
        useDES(Cipher.ENCRYPT_MODE, secretKey, in, out);
        in.close(); out.close();

        // Bob  Alice θ(pub)Ѥ secretNum Ź沽
        BigInteger encodedNum
          = secretNum.modPow(pub.getPublicExponent(), pub.getModulus());
        System.out.println("encodedNum=" + encodedNum);

        // Alice  Bob ΰŹʸ椹롡----------------
        System.out.println("Alice ¦");
        in = new FileInputStream("RSA.java.encoded");
        out = new FileOutputStream("RSA.java.decoded");

        // ̩(priv)Ѥ secretNum 椹
        RSAPrivateKey priv = test.privateKey;
        BigInteger decodedNum
          = encodedNum.modPow(priv.getPrivateExponent(), priv.getModulus());
        System.out.println("decodedNum=" + decodedNum);

        // Alice 椷(decodedNum)Ѥ DES θ
        keySpec = new DESKeySpec(decodedNum.toByteArray());
        secretKey = keyFactory.generateSecret(keySpec);

        // DES 椹
        useDES(Cipher.DECRYPT_MODE, secretKey, in, out);
        in.close(); out.close();
    }
}
