/**
 *  ٥ȥ륯饹
 *
 *  ٥ȥ(double )ФƼ黻᥽åɤ󶡤ޤ
 *
 *  @version $Revision: 1.6 $, $Date: 2003/03/13 14:24:35 $
 */
public class RVector {
    /**
     *  ͤ (lhs + rhs) Ȥʤ٥ȥ֤ޤ
     *  @param  lhs 
     *  @param  rhs 
     *  @return (lhs + rhs)
     */
    public static double[] add(double[] lhs, double[] rhs) {
        if (lhs.length != rhs.length)
            throw new IndexOutOfBoundsException();
        double[] ret = new double[lhs.length];
        for (int i = 0; i < lhs.length; i++) ret[i] = lhs[i] + rhs[i];
        return ret;
    }
    /**
     *  ͤ (lhs - rhs) Ȥʤ٥ȥ֤ޤ
     *  @param  lhs 
     *  @param  rhs 
     *  @return (lhs - rhs)
     */
    public static double[] subtract(double[] lhs, double[] rhs) {
        if (lhs.length != rhs.length)
            throw new IndexOutOfBoundsException();
        double[] ret = new double[lhs.length];
        for (int i = 0; i < lhs.length; i++) ret[i] = lhs[i] - rhs[i];
        return ret;
    }
    /**
     *  ͤ (a * v) Ȥʤ٥ȥ֤ޤ
     *  @param  a   顼
     *  @param  v   ٥ȥ
     *  @return (a * v)
     */
    public static double[] multiply(double a, double[] v) {
        double[] ret = new double[v.length];
        for (int i = 0; i < v.length; i++) ret[i] = a * v[i];
        return ret;
    }
    /**
     *  ٥ȥ ns ܤǤ ne - 1 ܤǤޤǤ
     *  Ѥ֤ޤ
     *  @param  ns  ¤ǽֹ
     *  @param  ne  ¤ǸǤμֹ
     *  @param  lhs 
     *  @param  rhs 
     *  @return Ѥ
     */
    public static double innerProduct(int ns, int ne,
                                      double[] lhs, double[] rhs) {
        if (ns < 0 || ne < 0 || ns > ne) throw new IndexOutOfBoundsException("error in RVector\n");
        double  s = 0.0;
        int n5 = (ne - ns) % 5;
        for (int i = ns; i < ns + n5; i++) s += lhs[i] * rhs[i];
        for (int i = ns + n5; i < ne; i += 5)
            s += lhs[i] * rhs[i] + lhs[i+1] * rhs[i+1]
               + lhs[i+2] * rhs[i+2] + lhs[i+3] * rhs[i+3]
               + lhs[i+4] * rhs[i+4];
        return s;
    }
    /**
     *  ٥ȥ ns ܤǤǸǤޤǤѤ֤ޤ
     *  @param  ns  ¤ǽֹ
     *  @param  lhs 
     *  @param  rhs 
     *  @return Ѥ
     */
    public static double innerProduct(int ns, double[] lhs, double[] rhs) {
        return innerProduct(ns, lhs.length, lhs, rhs);
    }
    /**
     *  ٥ȥѤ֤ޤ
     *  @param  lhs 
     *  @param  rhs 
     *  @return Ѥ
     */
    public static double innerProduct(double[] lhs, double[] rhs) {
        return innerProduct(0, lhs.length, lhs, rhs);
    }
/***************** ʲϰ᥽å ***************************************/
    /**
     *  ٥ȥ ns ܤǤ ne - 1 ܤǤ
     *  ޤ
     *  @see NumberFormatter
     *  @param  ns  Ϥǽֹ
     *  @param  ne  ǸǤμֹ
     *  @param  perline 1Ԥ˰ǿ
     *  @param  format  NumberFormatter Ϳ
     */
    public static void print(int ns, int ne, double[] v,
                                    int perLine, String format) {
        if (ns < 0 || ne < 0 || ns > ne) throw new IndexOutOfBoundsException();
        NumberFormatter fmt = new NumberFormatter(format);
        int k = 0;

        for (int j = ns; j < ne; j++) {
            System.out.print(fmt.toString(v[j]));
            if (++k >= perLine) {  k = 0;  System.out.println();  }
        }
        if (k != 0) System.out.println();
    }

    /**
     *  ٥ȥ ns ܤǤǸǤޤǤޤ
     *  @see NumberFormatter
     *  @param  ns      Ϥǽֹ
     *  @param  perLine 1Ԥ˰ǿ
     *  @param  format  NumberFormatter Ϳ
     */
    public static void print(int ns, double[] v, int perLine, String format) {
        print(ns, v.length, v, perLine, format);
    }
    /**
     *  ٥ȥǤޤ
     *  @see NumberFormatter
     *  @param  perLine 1Ԥ˰ǿ
     *  @param  format  NumberFormatter Ϳ
     */
    public static void print(double[] v, int perLine, String format) {
        print(0, v.length, v, perLine, format);
    }
}

