/**
* SWEEP.java -- SWEEP黻ˡ
* @version $Revision: 1.5 $, $Date: 2003/03/16 14:33:25 $
* ¿̥ǡɹߴط롼 StatData.java 
*/
import java.io.*;

/**
*SWEEP黻ˡȤäʬϤΥץǤ
*@see Regress
*@see StatData
*@see NumberFormatter
*/
public class SWEEP {
    static int n, m, ndf;   /* ǡη, ѿο, ͳ */
    static boolean[] added; /* ѿ˺Ѥ */
    static double[][] a;    /* ¹ */
    static final NumberFormatter FMT = new NumberFormatter("11.6f");

    static void sweep(int k) { /* ݤФ黻 */
        double d = a[k][k];

        if (d == 0) {
            System.out.println("ѿ " + k + " 켡°.");
            return;
        }
        for (int j = 0; j <= m; j++) a[k][j] /= d;
        for (int j = 0; j <= m; j++) {
            if (j == k) continue;
            double b = a[j][k];
            for (int i = 0; i <= m; i++) a[j][i] -= b * a[k][i];
            a[j][k] = -b / d;
        }
        a[k][k] = 1 / d;
        if (added[k]) {  added[k] = false;  ndf++;  }
        else          {  added[k] = true;   ndf--;  }
    }

    static void regress(int k) { /* ѿ k ˤĤƲ󵢷ʤɤ */
        if (added[k]) {  System.out.println("???");  return;  }
        double rms = (ndf > 0 && a[k][k] >= 0) ? Math.sqrt(a[k][k] / ndf) : 0;

        System.out.println("ѿ 󵢷   ɸ        t");
        for (int j = 0; j <= m; j++) {
            if (! added[j]) continue;
            double s = (a[j][j] >= 0) ? Math.sqrt(a[j][j]) * rms : 0;
            System.out.print(" " + j + FMT.toString(a[j][k]) + FMT.toString(s));
            if (s > 0) System.out.print("  " + FMT.toString(Math.abs(a[j][k] / s)));
            System.out.println();
        }
        System.out.println("ѿ: " + k + "  ĺ2: " +
            FMT.toString(a[k][k]) + "  ͳ: " + ndf + "  ĺRMS: " + FMT.toString(rms));
    }

    static void residuals() { /* ĺ¹ */
        for (int i = 0; i <= m; i += 5) {
            System.out.print(" ");
            for (int k = i; k < i + 5 && k <= m; k++)
                System.out.print("          " + k);
            System.out.println();
            for (int j = 0; j <= m; j++) {
                System.out.print("  "+ j + "  ");
                for (int k = i; k < i + 5 && k <= m; k++)
                    System.out.print(FMT.toString(a[j][k]));
                System.out.println();
            }
        }
    }
    /**
    *÷ʬϤΥץǤ<br>
    *<b>ˡ java SWEEP filename</b><br>
    *ܤʸɤ߲
    */
    public static void main(String[] args) throws IOException {
        System.out.print("********** ÷ʬ **********\n\n");
        if (args.length != 1) { /* åɽλ */
            System.err.println("ˡ: java SWEEP filename");
            System.exit(-1);
        }
        StatData dataFile = new StatData(args[0]);
        n = ndf = dataFile.numberOfRows();  m = dataFile.numberOfColumns();
        // n ޤ m ɤ߹ʤ class StatData ǥ顼
        System.out.println(n + "   " + m + " ѿ");
        a = new double[m + 1][m + 1];   // 0 ˽
        added = new boolean[m + 1];     // false ˽
        double[] x = new double[m + 1];

        for (int i = 0; i < n; i++) {
            System.out.print(".");  x[0] = 1;
            for (int j = 1; j <= m; j++) x[j] = dataFile.getNum();
            for (int j = 0; j <= m; j++)
                for (int k = j; k <= m; k++) a[j][k] += x[j] * x[k];
        }
        System.out.println();  dataFile.close();
        for (int j = 0; j <= m; j++)
            for (int k = 0; k < j; k++) a[j][k] = a[k][j];

        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        while (true) {
            System.out.print("̿(Xj/Yj/R/Q)? ");
            String s = in.readLine();
            char c = Character.toUpperCase(s.charAt(0));
            int j = 0;
            if (c == 'X' || c == 'Y') {
                try { j = Integer.parseInt(s.substring(1));
                } catch(NumberFormatException e) { j = -1; }
            }
            if (j < 0 || j > m) c = 0;
            switch (c) {
                case 'X' :  sweep(j);       break;
                case 'Y' :  regress(j);     break;
                case 'R' :  residuals();    break;
                case 'Q' :  return;
                default  :  System.out.println("???");
                            break;
            }
        }
    }
}
