/**
 *  Simplex.java -- ײˡ
 *
 *  @version $Revision: 2.13 $, $Date: 2003/03/21 20:37:38 $
 */

import java.io.*;
import java.util.*;
import java.text.*;

public class Simplex {
    static final double EPSILON = 1E-6;  // ̵¾
    /** 르ꥺѲʤѿ */
    static double[][] a;  // Ｐη
    static char[] inequality;  //  <, >, =
    static double[] c;    // Ūؿη
    static int m, n;      // ԡʾ, ѿˤο
    static int n1;        // n + Υåѿο
    static int n2;        // n1 + Υåѿο
    static int n3;        // n2 + Ͱѿο
    static int[] nonZeroRow;   // åͰѿ0Ǥʤ
    /** 르ꥺѲѿ */
    static double[][] q;  // Ѵ
    static int jmax;      // Ǳֹ
    static int[] col;     // ƹԤδѿֹ
    static int[] row;     // 󤬴ʤбֹ, Ǥʤ0

    /** 顼ɽ, λ */
    private static void exitError(String message) {
        System.err.println("\n" + message);  System.exit(1);
    }

    /** ｪλ */
    private static void exitNormal(String message) {
        System.out.println(message);  System.exit(0);
    }

    /** ¿Ѵ */
    private static double nextDouble(StringTokenizer t) {
        return Double.valueOf(t.nextToken()).doubleValue();
    }

    /** ɸϤǡɤ */
    private static void readData() throws IOException {
        BufferedReader in =
            new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer t = new StringTokenizer(in.readLine());
        m = Integer.parseInt(t.nextToken());
        n = Integer.parseInt(t.nextToken());
        if (m < 1) exitError("ο m  1 ̤Ǥ");
        if (n < 1) exitError("ѿο n  1 ̤Ǥ");
        System.out.println(m + "  " + n + " ѿ");

        a = new double[m + 1][n + 1];
        c = new double[n + 1];
        q = new double[m + 1][m + 1];
        col         = new int[m + 1];
        row         = new int[n + 2 * m + 1];
        nonZeroRow  = new int[n + 2 * m + 1];
        inequality  = new char[m + 1];

        t = new StringTokenizer(in.readLine());
        for (int j = 1; j <= n; j++) c[j] = nextDouble(t);
        c[0] = -nextDouble(t);  // c[0] դˤ

        for (int i = 1; i <= m; i++) {
            t = new StringTokenizer(in.readLine());
            for (int j = 1; j <= n; j++) a[i][j] = nextDouble(t);
            inequality[i] = t.nextToken().charAt(0);
            if ("<>=".indexOf(inequality[i]) == -1)
                exitError("ϥ顼");
            a[i][0] = nextDouble(t);
            if (a[i][0] < 0) {
                if      (inequality[i] == '>') inequality[i] = '<';
                else if (inequality[i] == '<') inequality[i] = '>';
                for (int j = 0; j <= n; j++) a[i][j] = -a[i][j];
            } else if (a[i][0] == 0 && inequality[i] == '>') {
                inequality[i] = '<';
                for (int j = 1; j <= n; j++) a[i][j] = -a[i][j];
            }
        }
    }

    /**  */
    private static void prepare() {
        n1 = n;
        for (int i = 1; i <= m; i++)
            if (inequality[i] == '>') {  //  -1 Υåѿ
                n1++;  nonZeroRow[n1] = i;
            }
        n2 = n1;
        for (int i = 1; i <= m; i++)
            if (inequality[i] == '<') {  //  +1 Υåѿ
                n2++;  col[i] = n2;
                nonZeroRow[n2] = row[n2] = i;
            }
        n3 = n2;
        for (int i = 1; i <= m; i++)
            if (inequality[i] != '<') {  // Ͱѿ
                n3++;  col[i] = n3;
                nonZeroRow[n3] = row[n3] = i;
            }
        for (int i = 0; i <= m; i++) q[i][i] = 1;
    }

    /** ץåɽ (i,j) ʬ׻ */
    private static double tableau(int i, int j) {
        if (col[i] < 0) return 0;  // ĹʾΤä
        if (j <= n) {
            double sum = 0;
            for (int k = 0; k <= m; k++) sum += q[i][k] * a[k][j];
            return sum;
        }
        double u = q[i][nonZeroRow[j]];
        if (j <= n1) return -u;
        if (j <= n2 || i != 0) return u;
        return u + 1;  // j > n2 && i == 0
    }

    /** ǥ󥹥ȥ졼Τ᥷ץåɽ */
    private static void printTableau() {  printTableau(-1, -1);  }
    private static void printTableau(int ipivot, int jpivot) {
        System.out.print("              ");
        for (int j = 1; j <= jmax; j++) {
            String s = (row[j]==0 ? "   " : "  @") + "x[" + j + "] ";
            System.out.print(s.substring(0, 8) +
                ((j == 0 || j == n || j == n2) ? "|" : ""));
        }
        System.out.println();
        final DecimalFormat df = new DecimalFormat("####0.00");
        for (int i = 0; i <= m; i++) {
            if (col[i] < 0) continue;  // Ĺʾ
            String s = "  " + i + ": ";
            System.out.print(s.substring(s.length() - 5));
            for (int j = 0; j <= jmax; j++) {
                s = "    " + df.format(tableau(i, j));
                System.out.print(s.substring(s.length() - 7) +
                    ((i == ipivot && j == jpivot) ? '*' : ' ') +
                    ((j == 0 || j == n || j == n2) ? "|" : ""));
            }
            System.out.println();
        }
    }

    /** ݤФ */
    private static void pivot(int ipivot, int jpivot,
                                          double[] pivotColumn) {
        System.out.println("ԥܥå(" + ipivot + "," + jpivot + ")");
        for (int j = 1; j <= m; j++)
            q[ipivot][j] /= pivotColumn[ipivot];
        for (int i = 0; i <= m; i++)
            if (i != ipivot) {
                final double u = pivotColumn[i];
                for (int j = 1; j <= m; j++)
                    q[i][j] -= q[ipivot][j] * u;
            }
        row[col[ipivot]] = 0;
        col[ipivot] = jpivot;  row[jpivot] = ipivot;
    }

    /** Ǿ */
    private static void minimize() {
        double[] pivotColumn = new double[m + 1];
        for ( ; ; ) {
            int jpivot;  // ԥܥå jpivot 򸫤Ĥ
            for (jpivot = 1; jpivot <= jmax; jpivot++)
                if (row[jpivot] == 0) {  // Ǥʤ
                    pivotColumn[0] = tableau(0, jpivot);
                    if (pivotColumn[0] < -EPSILON) break;
                }
            if (jpivot > jmax) break;  // Ǿλ
            int ipivot = 0;  // ԥܥåȹ ipivot 򸫤Ĥ
            double uMin = Double.MAX_VALUE;
            for (int i = 1; i <= m; i++) {
                pivotColumn[i] = tableau(i, jpivot);
                if (pivotColumn[i] > EPSILON) {
                    double u = tableau(i, 0) / pivotColumn[i];
                    if (u < uMin) {  ipivot = i;  uMin = u;  }
                }
            }
            if (ipivot == 0) exitNormal("Ūؿϲ¤ޤ");
            printTableau(ipivot, jpivot);
            pivot(ipivot, jpivot, pivotColumn);
        }
        printTableau();
        System.out.println("Ǿͤ " + (-tableau(0, 0)) + " Ǥ");
    }

    /** ե */
    private static void phase1() {
        System.out.println("ե");
        jmax = n3;
        for (int j = n2 + 1; j <= n3; j++) q[0][row[j]] = -1;
        minimize();
        if (tableau(0, 0) < -EPSILON) exitNormal("ǽʲϤޤ");
        for (int i = 1; i <= m; i++)  // Ͱѿʤ
            if (col[i] > n2) {
                int j;
                for (j = 1; j <= n; j++)
                    if (row[j] == 0
                        && Math.abs(tableau(i, j)) > EPSILON) {
                        // System.out.println("ޤʾǤν");
                        double[] pivotColumn = new double[m + 1];
                        for (int k = 0; k <= m; k++)
                            pivotColumn[k] = tableau(k, j);
                        pivot(i, j, pivotColumn);
                        break;
                    }
                if (j > n) {
                    System.out.println(" " + i + " ϾĹǤ");
                    col[i] = -1;
                }
            }
        q[0][0] = 1;  //  եظ
        for (int i = 1; i <= m; i++) q[0][i] = 0;
        for (int j = 1; j <= n; j++)
            if (row[j] != 0 && c[j] != 0)
                for (int i = 1; i <= m; i++)
                    q[0][i] -= q[row[j]][i] * c[j];
    }

    /** ե */
    private static void phase2() {
        System.out.println("ե");
        jmax = n2;
        for (int j = 0; j <= n; j++) a[0][j] = c[j];  // Ūؿ
        minimize();
    }

    /** ̤ν */
    private static void printVariable() {
        System.out.println("0 Ǥʤѿ:");
        for (int j = 1; j <= n; j++) {
            final int i = row[j];
            if (i != 0)
                System.out.println("x[" + j + "] = " + tableau(i, 0));
        }
    }

    public static void main(String[] args) throws IOException {
        readData();                 // ǡɤ
        prepare();                  // 館
        if (n3 != n2) phase1();     // ե1
        phase2();                   // ե2
        printVariable();            // ̤ν
    }
}
