/**
 *  󥻡륹ޥ
 *
 *  @version $Revision: 1.5 $, $Date: 2003/03/02 15:29:19 $
 */

import java.io.*;
import java.util.*;

public class TSP {
    static int n, d[][], tour[], tourLength;

    /** ϩ */
    private static void printTour() {
        System.out.print("ϩ = [ ");
        for (int i = 0; i < n; i++) System.out.print(tour[i] + " ");
        System.out.println("] Υ = " + tourLength);
    }

    /** ϩnearest neighborˡ */
    private static void initialTour() {
        boolean used[] = new boolean[n];
        for (int i = 0; i < n; i++) used[i] = false;
        int current = (int)(Math.random() * n);
        for (int i = 0; i < n; i++) {
            tour[i] = current;  used[current] = true;
            int minj = 0,  min = Integer.MAX_VALUE;
            for (int j = 0; j < n; j++)
                if (!used[j] && d[current][j] < min) {
                    min = d[current][j];  minj = j;
                }
            current = minj;  // ̤κǤᤤԻ
        }
        tourLength = 0;  // ϩεΥ׻
        for (int i = 0; i < n; i++)
            tourLength += d[tour[i]][tour[(i + 1) % n]];
    }

    /** 2-opt ˤιʼ˸򺹤ޤʤ */
    private static boolean twoOpt(final int a) {
        final int a1 = tour[a % n],  a2 = tour[(a + 1) % n];
        for (int b = a + 2; b < a + n - 1; b++) {
            final int b1 = tour[b % n],  b2 = tour[(b + 1) % n];
            int diff = - (d[a1][a2] + d[b1][b2])
                       + (d[a1][b1] + d[a2][b2]);
            if (diff < 0) {  // ɲȯ
                tourLength += diff;
                System.out.println("ߤεΥ(2-opt) = " + tourLength);
                for (int i = 0; i < (b - a) / 2; i++) {  // ɲ¸
                    int swap = tour[(a + 1 + i) % n];
                    tour[(a + 1 + i) % n] = tour[(b - i) % n];
                    tour[(b - i) % n] = swap;
                }
                return true;  // ɤ
            }
        }
        return false;  // ɤʤ
    }

    private static void orOptModify(int a, int b, int c, int diff,
                                    boolean reverse) {
        tourLength += diff;
        System.out.println("ߤεΥ(Or-opt) = " + tourLength);
        int len = b - a,  tmp[] = new int[len];
        for (int i = 0; i < len; i++) tmp[i] = tour[(a + 1 + i) % n];
        for (int i = b + 1; i <= c; i++)
            tour[(i - len) % n] = tour[i % n];
        for (int i = 0; i < len; i++)
            tour[(c - i) % n] = (!reverse) ? tmp[i] : tmp[len - 1 - i];
    }

    /** Or-opt ˤι14ĤԻԤдߤνϩ˰ܤ */
    private static boolean orOpt(final int a) {
        final int a1 = tour[a % n],  a2 = tour[(a + 1) % n];
        for (int b = a + 1; b <= a + 4; b++) {
            final int b1 = tour[b % n],  b2 = tour[(b + 1) % n];
            for (int c = b + 1; c < a + n - 1; c++) {
                final int c1 = tour[c % n],  c2 = tour[(c + 1) % n];
                final int before = d[a1][a2] + d[b1][b2] + d[c1][c2];
                int after =        d[a1][b2] + d[a2][c2] + d[b1][c1];
                if (after - before < 0) {  // ɲȯ
                    orOptModify(a, b, c, after - before, false);
                    return true;  // ɤ
                }
                if (b == a + 1) continue;
                after = d[a1][b2] + d[a2][c1] + d[b1][c2];
                if (after - before < 0) {  // ո³ǲɲȯ
                    orOptModify(a, b, c, after - before, true);
                    return true;  // ɤ
                }
            }
        }
        return false;  // ɤʤ
    }

    public static int[][] readDistance() throws IOException {
        BufferedReader in =
            new BufferedReader(new InputStreamReader(System.in));
        final int n = Integer.parseInt(in.readLine());
        int[] x = new int[n],  y = new int[n];
        int[][] distance = new int[n][n];
        for (int i = 0; i < n; i++) {
            StringTokenizer t = new StringTokenizer(in.readLine());
            x[i] = Integer.parseInt(t.nextToken());
            y[i] = Integer.parseInt(t.nextToken());
            for (int j = 0; j < i; j++) {
                final int dx = x[i] - x[j];
                final int dy = y[i] - y[j];
                distance[i][j] = distance[j][i] =
                //  (int)Math.round(Math.sqrt(dx * dx + dy * dy));  // ̾
                    (int)Math.ceil(Math.sqrt((dx * dx + dy * dy) / 10.0));
            }
        }
        System.out.println("Ի x  y");
        for (int i = 0; i < n; i++)
            System.out.println(i + " " + x[i] + " " + y[i]);
        return distance;
    }

    public static void main(String[] args) throws IOException {
        d = readDistance();  n = d.length;  // Υɤ߹
        tour = new int[n];  initialTour();
        System.out.println("ϩ");  printTour();
        for (int i = 0, last = 0; i < last + n; i++)  // ɽõ (2-opt)
            if (twoOpt(i)) last = i + 1;
        for (int i = 0, last = 0; i < last + n; i++)  // ɽõ (Or-opt)
            if (orOpt(i)) last = i + 1;
        System.out.println("ɽŬ");  printTour();
    }
}
