/**
 *  Ҥդ2ʬ
 *
 *  @version $Revision: 1.4 $, $Date: 2003/04/28 23:23:20 $
 */

import java.io.*;

public class ThreadedBinaryTree {
    class Node {  // ڤΥΡ
        Node left, right;  // λҤؤΥݥ
        boolean isLeftThread, isRightThread;  // ݥ󥿤Ҥ⤫ɤ
        String key;        // õΥϿʸ
        int count;         // Ȳ

        // Ρɤ
        Node(String key, Node left, boolean isLeftThread,
                         Node right, boolean isRightThread) {
            this.key = key;  // 򥳥ԡ
            count = 1;         // Ȳ1ˤ
            this.left  = left;   this.isLeftThread =  isLeftThread;
            this.right = right;  this.isRightThread = isRightThread;
        }

        private void insertLeft(String key) {  // ΥΡɤκ
            Node q = new Node(key,        // Ρɤ
                     left, isLeftThread,  // λҤϿƤκλҤѤ
                     this, true);         // λҤϿƤؤҤ
            left = q;                // {\tt q} ơʤΥΡɡˤκλҤˤ
            isLeftThread = false;    // {\tt q} ϤҤǤʤ
        }

        private void insertRight(String key) {  // ΥΡɤα
            Node q = new Node(key, this, true, right, isRightThread);
            right = q;  isRightThread = false;  //  {\tt insertLeft()} 
        }

        private Node successor() {  // ǤľΥΡ
            // ${\tt right} \leftrightarrow {\tt left}$, ${\tt isRightThread} \leftrightarrow {\tt isLeftThread}$ ȤľΥΡɤˤʤ
            Node node = right;
            if (!isRightThread)
                while (!node.isLeftThread) node = node.left;
            return node;
        }
    }

    Node root;  // ڤκ

    ThreadedBinaryTree() {
        root = new Node(null, null, true, null, true);
        root.left = root.right = root;
    }

    public void insertNode(String key) {  // (Ͽ)
        Node node = root;
        int cmp = 1;  // ӷ̡ʺǽλҤϿƤαˡ
        do {
            if (cmp < 0) {    // кϿ
                if (!node.isLeftThread) node = node.left;
                else {  node.insertLeft(key);  return;  }
            } else {          // 礭бϿ
                if (!node.isRightThread) node = node.right;
                else {  node.insertRight(key);  return;  }
            }
        } while ((cmp = key.compareTo(node.key)) != 0);
        node.count++;           // лȲ
    }

    void printNode() {  // 
        Node node = root;
        while ((node = node.successor()) != root)
            System.out.println(node.key + " " + node.count);
    }

    public static void main(String[] args) throws IOException {
        StreamTokenizer input =
            new StreamTokenizer(new InputStreamReader(System.in));

        ThreadedBinaryTree tree = new ThreadedBinaryTree();
        while (input.nextToken() != input.TT_EOF)
            if (input.ttype == input.TT_WORD)  // ɸϤ
                tree.insertNode(input.sval);  // ñɤϿ
        tree.printNode();    // ñȽи򾺽˽
    }
}
