/**
 *  TreeCurve.java -- ڶ
 *  (DrawOneByOnePanel.java, Plotter.java Ȥ)
 *
 *  @version $Revision: 1.7 $, $Date: 2003/03/18 10:05:54 $
 */

import java.awt.*;
import javax.swing.*;

public class TreeCurve extends DrawOneByOnePanel {
    static final int WIDTH = 400,  HEIGHT = WIDTH;
    static final double FACTOR = 0.7,  TURN = 0.5;
    private int order;  // ̿

    public TreeCurve(int order) {
        super(WIDTH + 1, HEIGHT + 1, 0);  this.order = order;
    }

    public int getOrder() {  return order;  }

    public void draw(Plotter pt, int n, double length, double angle) {
        double dx = length * Math.sin(angle);
        double dy = length * Math.cos(angle);
        pt.drawRelative(dx, dy);
        if (n > 0) {
            draw(pt, n - 1, length * FACTOR, angle + TURN);
            draw(pt, n - 1, length * FACTOR, angle - TURN);
        } else sleep(500 / order / order);  // ɽԤ
        pt.moveRelative(-dx, -dy);
    }

    synchronized public void drawSlowly(Graphics2D g) {
        g.translate(WIDTH / 2, HEIGHT);  g.scale(1, -1);  // 沼
        Plotter pt = new Plotter(g);
        pt.moveTo(0, 0);  draw(pt, order, WIDTH / 4, 0);
    }

    public static void main(String[] args) {
        JFrame frame = new JFrame("ڶ");
        TreeCurve p1 = new TreeCurve(10);
        TreeCurve p2 = new TreeCurve(12);
        Container c = frame.getContentPane();

        Box b = new Box(BoxLayout.Y_AXIS);
        b.add(new JLabel("̿ = " + p1.getOrder()));
        b.add(p1);
        c.add(b, BorderLayout.WEST);

        b = new Box(BoxLayout.Y_AXIS);
        b.add(new JLabel("̿ = " + p2.getOrder()));
        b.add(p2);
        c.add(b, BorderLayout.EAST);

        frame.pack();               // Ŭڤ礭
        frame.setDefaultCloseOperation(frame.EXIT_ON_CLOSE);
        frame.setResizable(false);  // ѹԲ
        frame.setVisible(true);     // ɽ
        p1.start();
        p2.start();
    }
}
