/*
* Tridiagonalize.java -- 3гѲ
* $Revision: 1.8 $, $Date: 2003/04/28 23:23:20 $
* class RMatrix, RVector Ȥ
*/
import java.io.*;
/**
*оι3гѹˤץǤ
*@see Householder
*@see QR
*@see RMatrix
*@see RVector
*/
public class Tridiagonalize {
    // ٥ȥ(x[k],...x[n-1]) Householder Ѵ
    static double house(int n, double[] x, int k) {
    // Ѥʿ, ʤ٥ȥ $x$ 礭
        double s = Math.sqrt(RVector.innerProduct(k, x, x));
        if (s != 0) {
            if (x[k] < 0) s = -s;
            x[k] += s;
            double t = 1 / Math.sqrt(x[k] * s);
            for (int i = 0; i < n; i++) x[k + i] *= t;
        }
        return -s;
    }
    /**
    * a[][] 3гѲޤ
    *@param a оιnn
    *@param d гʬ<code>d[0]...d[n-1]</code>ޤ
    *@param e ٤ʬ<code>e[0]...e[n-2]</code>ޤ
    */
    public static void getMatrix(double[][] a, double[] d, double[] e) {
        int n = a.length;

        for (int k = 0; k < n - 2; k++) {
// ʸv = a[k];a[][]kԤv[]=(a[k][0],a[k][1], ...a[k][n-1])ˤʤ롣
            double[] v = a[k];  d[k] = v[k];
            e[k] = house(n - k - 1, v, k + 1);
            if (e[k] == 0) continue;
            for (int i = k + 1; i < n; i++) {
                double s = 0;
                for (int j = k + 1; j < i; j++) s += a[j][i] * v[j];
                for (int j = i;     j < n; j++) s += a[i][j] * v[j];
                d[i] = s;
            }
            double t = RVector.innerProduct(k + 1, v, d) / 2;
            for (int i = n - 1; i > k; i--) {
                double p = v[i], q = d[i] - t * p;  d[i] = q;
                for (int j = i; j < n; j++)
                    a[i][j] -= p * d[j] + q * v[j];
            }
        }
        if (n >= 2) {  d[n - 2] = a[n - 2][n - 2];
                       e[n - 2] = a[n - 2][n - 1];  }
        if (n >= 1)    d[n - 1] = a[n - 1][n - 1];
        for (int k = n - 1; k >= 0; k--) {
            double[] v = a[k];
            if (k < n - 2) {
                for (int i = k + 1; i < n; i++) {
                    double[] w = a[i];
                    double t = RVector.innerProduct(k + 1, v, w);
                    for (int j = k + 1; j < n; j++)
                        w[j] -= t * v[j];
                }
            }
            for (int i = 0; i < n; i++) v[i] = 0;
            v[k] = 1;
        }
    }

    /**
    * ȤäץǤ<br>
    *<b>&quot;n = &quot;</b>ʹƤޤ 3 ʾ()ϤƤ<br>
    *ι A3гѲгʬ<code>d[]</code>Ȥ٤ʬ<code>e[]</code>
    *ʿѸϤޤ
    */
    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        System.out.print("n = ");
        int n = Integer.parseInt(in.readLine());
        double a[][]  = new double[n][n], p[][] = new double[n][n],
               d[]    = new double[n],    e[]   = new double[n],
               temp[] = new double[n];

        for (int i = 0; i < n; i++)
            for (int j = 0; j <= i; j++)
                a[i][j] = a[j][i] = p[i][j] = p[j][i]
                    = Math.random() - Math.random();

        String fmt = "15.10f";
        System.out.println("A:");   RMatrix.print(a, 5, fmt);
        getMatrix(p, d, e);
        System.out.println("d:");   RVector.print(d, 5, fmt);
        System.out.println("e:");   RVector.print(0, n - 1, e, 5, fmt);
        for (int i = 0; i < n; i++) {
            for (int k = 0; k < n; k++)
                temp[k] = a[i][k];
            for (int j = 0; j < n; j++) {
                double s = 0;
                for (int k = 0; k < n; k++)
                    s += temp[k] * p[j][k];
                a[i][j] = s;
            }
        }
        for (int j = 0; j < n; j++) {
            for (int k = 0; k < n; k++)
                temp[k] = a[k][j];
            for (int i = 0; i < n; i++) {
                double s = 0;
                for (int k = 0; k < n; k++)
                    s += p[i][k] * temp[k];
                a[i][j] = s;
            }
        }
        double s = 0, t;
        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                if (i == j) {
                    t = a[i][j] - d[i];  s += t * t;
                } else if (i + 1 == j) {
                    t = a[i][j] - e[i];  s += t * t;
                } else if (i == j + 1) {
                    t = a[i][j] - e[j];  s += t * t;
                } else {
                    t = a[i][j];  s += t * t;
                }
// 1E-16 ٤ˤʤ롣
        System.out.println("ʿѸ: " + Math.sqrt(s) / n);
    }
}
